// DontShowMeYNC.cpp : implementation file
//

#include "stdafx.h"
#include "newpgen.h"
#include "DontShowMeYNC.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// DontShowMeYNC dialog


DontShowMeYNC::DontShowMeYNC(char *prompt, bool *alwayssave, CWnd* pParent /*=NULL*/)
	: CDialog(DontShowMeYNC::IDD, pParent), m_prompt (prompt), m_alwayssave (alwayssave)
{
	//{{AFX_DATA_INIT(DontShowMeYNC)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void DontShowMeYNC::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(DontShowMeYNC)
	DDX_Control(pDX, IDC_PROMPT, m_Prompt);
	DDX_Control(pDX, IDC_CHECK1, m_Check);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(DontShowMeYNC, CDialog)
	//{{AFX_MSG_MAP(DontShowMeYNC)
	ON_BN_CLICKED(IDDONTSAVE, OnDontsave)
	ON_BN_CLICKED(IDSAVE, OnSave)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// DontShowMeYNC message handlers

BOOL DontShowMeYNC::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	if (*m_alwayssave)
	{
		m_Button = IDYES;	
		CDialog::OnOK();
	}
	
	m_Prompt.SetWindowText (m_prompt);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void DontShowMeYNC::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	m_Button = IDCANCEL;	
	CDialog::OnCancel();
}

void DontShowMeYNC::OnDontsave() 
{
	// TODO: Add your control notification handler code here
	m_Button = IDNO;	

	if (m_Check.GetCheck ()) 
	{
		*m_alwayssave = true;
	}	
	CDialog::OnOK();
}

void DontShowMeYNC::OnSave() 
{
	// TODO: Add your control notification handler code here
	m_Button = IDYES;	

	if (m_Check.GetCheck ()) 
	{
		*m_alwayssave = true;
	}
	CDialog::OnOK();
}
