#if !defined(__GNUC__) && !defined(_CONSOLE)		// VC GUI Platform

// newpgenDlg.cpp : implementation file
//

#include <stdlib.h>
#include <process.h>
#include "stdafx.h"
#include "newpgen.h"
#include "newpgen2.h"
#include "newpgenDlg.h"
#include "print.h"
#include "Contents.h"
#include "EditDrop.h"
#include "DlgMaxBitmapSize.h"
#include "DontShowMe.h"
#include "DontShowMeYNC.h"
#include "IterationsBetweenWrites.h"
#include "frmSieveUntil.h"
#include "frmSplit.h"
#include "frmMerge.h"
#include "frmTestSplit.h"
#include "primetable.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define PRODUCTNAME "NewPGen 2.82"

bool fAutoIncrement;
bool fPFGW;
char PFGWParameters[100];
int AutoIncrementAmount;

int InitialSieveLimit;

bool DSM_LogDeleted = false;
bool DSM_TwoSaveFiles = false;
bool DSM_DSMYNC = false;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNewpgenDlg dialog

CNewpgenDlg::CNewpgenDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CNewpgenDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CNewpgenDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	Create (IDD, pParent);
}

void CNewpgenDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNewpgenDlg)
	DDX_Control(pDX, IDC_BUTTONFOUT, m_ButtonFout);
	DDX_Control(pDX, IDC_BUTTONFIN, m_ButtonFin);
	DDX_Control(pDX, IDC_STATICORIG, m_StaticOrig);
	DDX_Control(pDX, IDC_CHECKEVEN, m_CheckEven);
	DDX_Control(pDX, IDC_CHECKGENERALIZED, m_Generalized);
	DDX_Control(pDX, IDC_STATICN, m_StaticN);
	DDX_Control(pDX, IDC_STATICKMIN, m_StaticKMin);
	DDX_Control(pDX, IDC_STATICKMAX, m_StaticKMax);
	DDX_Control(pDX, IDC_STATICRATE, m_StaticRate);
	DDX_Control(pDX, IDC_CHECKVERIFY, m_CheckVerify);
	DDX_Control(pDX, IDC_CHECKPRIMORIAL, m_CheckPrimorial);
	DDX_Control(pDX, IDC_RADIOPNORMAL, m_PNormal);
	DDX_Control(pDX, IDC_RADIOPIDLE, m_PIdle);
	DDX_Control(pDX, IDC_RADIOPHIGH, m_PHigh);
	DDX_Control(pDX, IDC_EDITOUTFILE, m_EditOutFile);
	DDX_Control(pDX, IDC_EDITINFILE, m_EditInFile);
	DDX_Control(pDX, IDC_STATICSTATUS, m_Status);
	DDX_Control(pDX, IDC_RADIOOLD, m_RadioOld);
	DDX_Control(pDX, IDC_RADIONEW, m_RadioNew);
	DDX_Control(pDX, IDSTART, m_StartButton);
	DDX_Control(pDX, IDC_EDIT7, m_Edit);
	DDX_Control(pDX, IDC_STATICCCLEN, m_StaticCCLen);
	DDX_Control(pDX, IDC_COMBO1, m_ComboType);
	DDX_Control(pDX, IDC_STATICBASE, m_StaticB1);
	DDX_Control(pDX, IDC_EDITN, m_EditN);
	DDX_Control(pDX, IDC_EDITKMIN, m_EditKMin);
	DDX_Control(pDX, IDC_EDITKMAX, m_EditKMax);
	DDX_Control(pDX, IDC_EDITCCLEN, m_EditCCLen);
	DDX_Control(pDX, IDC_EDITBASE, m_EditBase);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CNewpgenDlg, CDialog)
	//{{AFX_MSG_MAP(CNewpgenDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_RADIOOLD, OnRadioold)
	ON_BN_CLICKED(IDC_RADIONEW, OnRadionew)
	ON_CBN_SELCHANGE(IDC_COMBO1, OnSelchangeCombo1)
	ON_EN_KILLFOCUS(IDC_EDITCCLEN, OnKillfocusEditcclen)
	ON_EN_SETFOCUS(IDC_EDITINFILE, OnSetfocusEditinfile)
	ON_EN_KILLFOCUS(IDC_EDITINFILE, OnKillfocusEditinfile)
	ON_WM_COPYDATA()
	ON_EN_KILLFOCUS(IDC_EDITBASE, OnKillfocusEditbase)
	ON_EN_KILLFOCUS(IDC_EDITN, OnKillfocusEditn)
	ON_EN_KILLFOCUS(IDC_EDITKMIN, OnKillfocusEditkmin)
	ON_EN_KILLFOCUS(IDC_EDITKMAX, OnKillfocusEditkmax)
	ON_BN_CLICKED(IDSTART, OnStart)
	ON_COMMAND(ID_FILE_EXIT, OnFileExit)
	ON_COMMAND(ID_M_ABOUT, OnMAbout)
	ON_COMMAND(ID_M_CONTENTS, OnMContents)
	ON_WM_SIZE()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_RADIOPHIGH, OnRadiophigh)
	ON_BN_CLICKED(IDC_RADIOPIDLE, OnRadiopidle)
	ON_BN_CLICKED(IDC_RADIOPNORMAL, OnRadiopnormal)
	ON_COMMAND(ID_OPTION_TRAYICON, OnOptionTrayicon)
	ON_COMMAND(ID_OPTION_WORKERTHREADPRIORITY_LOWEST, OnOptionWorkerthreadpriorityLowest)
	ON_COMMAND(ID_OPTION_WORKERTHREADPRIORITY_NORMAL, OnOptionWorkerthreadpriorityNormal)
	ON_COMMAND(ID_OPTIONS_HIDE, OnOptionsHide)
	ON_BN_CLICKED(IDC_CHECKPRIMORIAL, OnCheckprimorial)
	ON_BN_CLICKED(IDC_CHECKVERIFY, OnCheckverify)
	ON_COMMAND(ID_OPTIONS_SETBITMAPSIZE, OnOptionsSetbitmapsize)
	ON_COMMAND(ID_OPTIONS_SETITERATIONSETWEENWRITES, OnOptionsSetiterationsetweenwrites)
	ON_COMMAND(ID_MSIEVEUNTIL, OnMsieveuntil)
	ON_COMMAND(ID_OPTIONS_LOG, OnOptionsLog)
	ON_BN_CLICKED(IDC_CHECKGENERALIZED, OnCheckgeneralized)
	ON_COMMAND(ID_HELP_WHATSNEWINTHISRELEASE, OnHelpWhatsnewinthisrelease)
	ON_COMMAND(ID_OPTIONS_USETWOSAVEFILES, OnOptionsUsetwosavefiles)
	ON_COMMAND(ID_UTILS_SEVERAL_SPLIT, OnUtilsSeveralSplit)
	ON_COMMAND(ID_UTILS_SEVERAL_MERGE, OnUtilsSeveralMerge)
	ON_BN_CLICKED(IDC_BUTTONFIN, OnButtonfin)
	ON_BN_CLICKED(IDC_BUTTONFOUT, OnButtonfout)
	ON_COMMAND(ID_SERVICES_PRIMALITYTESTONSEVERALMACHINES, OnServicesPrimalitytestonseveralmachines)
	ON_COMMAND(ID_OPTIONS_AUTOMATICALLYCONTINUESIEVINGTHELASTFILEONSTARTUP, OnOptionsAutomaticallycontinuesievingthelastfileonstartup)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_USER + 1, OnTrayMessage)
	ON_NOTIFY_EX( TTN_NEEDTEXT, 0, OnToolTip)

END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNewpgenDlg message handlers

#define IDM_ABOUTBOX 0x2320

bool fAutoStartHidden = false;

BOOL CNewpgenDlg::OnInitDialog()
{
	bool fTwoSaveFilesInIniFile = false; 
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	EnableToolTips (true);

	WorkerThread = NULL;

	FillPrimetable ();
	initialise ();

	fTest = false;

	fAutoIncrement = false;
	LogDeleted = false;

	m_RadioNew.SetCheck (1);
	m_RadioOld.SetCheck (0);
	UpdateData (false);
	OnRadionew();
	m_PNormal.SetCheck (1);
	m_CheckVerify.SetCheck (0);
	fVerify = 0;
	WriteIterations = 30;

	GetSystemMenu(false)->EnableMenuItem (SC_SIZE, MF_BYCOMMAND|MF_GRAYED);
	GetSystemMenu(false)->EnableMenuItem (SC_MOVE, MF_BYCOMMAND|MF_GRAYED);
	GetSystemMenu(false)->EnableMenuItem (SC_MAXIMIZE, MF_BYCOMMAND|MF_GRAYED);
	GetMenu()->CheckMenuItem (ID_OPTION_WORKERTHREADPRIORITY_LOWEST, MF_BYCOMMAND | MF_CHECKED);
	GetMenu()->CheckMenuItem (ID_OPTION_WORKERTHREADPRIORITY_NORMAL, MF_BYCOMMAND | MF_UNCHECKED);
	GetMenu()->CheckMenuItem (ID_OPTION_TRAYICON, MF_BYCOMMAND | MF_CHECKED);
	GetMenu ()->EnableMenuItem (ID_OPTIONS_HIDE, MF_BYCOMMAND|MF_GRAYED);

	bool fAutoStart = false;
	char AutoRunFile[1024];

	fAutoStartHidden = false;

	FILE *fptr = fopen ("NewPGen.ini", "r");
	if (fptr)
	{
		char buff[1024], param[1024], value[1024];

		while (!feof (fptr))
		{
			if (fgets (buff, 1024, fptr) == NULL) break;
			buff[strlen(buff) - 1] = 0;
			sscanf (buff, "%[^= ] = %[^\0]", param, value);

			if (!_stricmp (param, "TrayIcon"))
			{
				GetMenu()->CheckMenuItem (ID_OPTION_TRAYICON, MF_BYCOMMAND | (atoi (value) ? MF_CHECKED : MF_UNCHECKED));
			}
			else if (!_stricmp (param, "Priority"))
			{
				if (value[0] == 'H')
				{
					m_PIdle.SetCheck (0);
					m_PHigh.SetCheck (1);
					m_PNormal.SetCheck (0);

					SetPriorityClass (GetCurrentProcess (), HIGH_PRIORITY_CLASS);
					SetThreadPriority (GetCurrentThread (), THREAD_PRIORITY_HIGHEST);
				}
				else if (value[0] == 'I')
				{
					m_PIdle.SetCheck (1);
					m_PHigh.SetCheck (0);
					m_PNormal.SetCheck (0);

					SetPriorityClass (GetCurrentProcess (), IDLE_PRIORITY_CLASS);
					SetThreadPriority (GetCurrentThread (), THREAD_PRIORITY_IDLE);
				}
				else
				{
					m_PIdle.SetCheck (0);
					m_PHigh.SetCheck (0);
					m_PNormal.SetCheck (1);

					SetPriorityClass (GetCurrentProcess (), NORMAL_PRIORITY_CLASS);
					SetThreadPriority (GetCurrentThread (), THREAD_PRIORITY_NORMAL);
				}

			}
			else if (!_stricmp (param, "WorkerThreadPriorityLowest"))
			{
				GetMenu()->CheckMenuItem (ID_OPTION_WORKERTHREADPRIORITY_LOWEST, MF_BYCOMMAND | (atoi (value) ? MF_CHECKED : MF_UNCHECKED));
				GetMenu()->CheckMenuItem (ID_OPTION_WORKERTHREADPRIORITY_NORMAL, MF_BYCOMMAND | (atoi (value) ? MF_UNCHECKED : MF_CHECKED));
			}
			else if (!_stricmp (param, "BitmapThreshold"))
			{
				BitMapThreshold = _atoi64 (value);
			}
			else if (!_stricmp (param, "MinutesBetweenWrites"))
			{
				WriteIterations = atoi (value);

				if (WriteIterations < 1) WriteIterations = 1;
			}
			else if (!_stricmp (param, "DSM_LogDeleted"))
			{
				DSM_LogDeleted = (atoi (value) == 1);
			}
			else if (!_stricmp (param, "DSM_TwoSaveFiles"))
			{
				DSM_TwoSaveFiles = (atoi (value) == 1);
			}
			else if (!_stricmp (param, "DSM_AlwaysSave"))
			{
				DSM_DSMYNC = (atoi (value) == 1);
			}
			else if (!_stricmp (param, "TwoSaveFiles"))
			{
				fTwoSaveFilesInIniFile = true;
				TwoSaveFiles = (atoi (value) == 1);
				GetMenu()->CheckMenuItem (ID_OPTIONS_USETWOSAVEFILES, MF_BYCOMMAND | (TwoSaveFiles ? MF_CHECKED : MF_UNCHECKED));
			}
			else if (!_stricmp (param, "PJTEST"))
			{
				fTest = true;
			}
			else if (!_stricmp (param, "InputFileName"))
			{
				GetMenu()->CheckMenuItem (ID_OPTIONS_AUTOMATICALLYCONTINUESIEVINGTHELASTFILEONSTARTUP, MF_BYCOMMAND | MF_CHECKED);
				strcpy (AutoRunFile, value);

				fAutoStart = true;
			}
			else if (!_stricmp (param, "Hidden"))
			{
				fAutoStartHidden = (atoi (value) == 1);
			}
		}

		fclose (fptr);
	}

	if (!fTwoSaveFilesInIniFile) 
	{ 
		AfxMessageBox ("There is a new Option to use two save files. It is highly recommended that you use this option right now.\n"); 
	} 

	OnCheckprimorial ();

	State = 0;

	if (fAutoStart)
	{
		m_RadioOld.SetCheck (1);
		OnRadioold ();
		m_EditInFile.SetWindowText (AutoRunFile);
		m_EditOutFile.SetWindowText (AutoRunFile);
		
		OnStart ();
		// Did it work?
		if (m_ButtonFin.IsWindowEnabled ())
		{
			// No!
			ShowWindow (SW_SHOWNORMAL);
			m_Edit.SetWindowText ("The sieve could not continue sieving the previous file!");
			if (GetMenu ()->GetMenuState (ID_OPTION_TRAYICON, MF_BYCOMMAND) & MF_CHECKED)
			{
				TrayMessage(NIM_ADD, PRODUCTNAME);
			}
		}
		else if (fAutoStartHidden)
		{
			// We should autostart hidden
			ShowWindow (SW_HIDE);
		}
		else
		{
			if (GetMenu ()->GetMenuState (ID_OPTION_TRAYICON, MF_BYCOMMAND) & MF_CHECKED)
			{
				TrayMessage(NIM_ADD, PRODUCTNAME);
			}
			ShowWindow(SW_MINIMIZE);
		}
	}
	else
	{
		if (GetMenu ()->GetMenuState (ID_OPTION_TRAYICON, MF_BYCOMMAND) & MF_CHECKED)
		{
			TrayMessage(NIM_ADD, PRODUCTNAME);
		}
		ShowWindow (SW_SHOWNORMAL);
	}

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CNewpgenDlg::TrayMessage(UINT message, LPCSTR prompt)
{
	NOTIFYICONDATA tnd;

	switch (message)
	{
	case NIM_ADD :
		tnd.uFlags = NIF_MESSAGE | NIF_ICON | NIF_TIP;
		break;
	case NIM_MODIFY :
		tnd.uFlags = NIF_TIP;
		break;
	case NIM_DELETE :
		tnd.uFlags = 0;
		break;
	}

	tnd.cbSize = sizeof(tnd);
	tnd.hWnd = m_hWnd;
	tnd.uID = 353;
	tnd.uCallbackMessage = WM_USER + 1;
	tnd.hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	strncpy(tnd.szTip, prompt, 64);

	Shell_NotifyIcon(message, &tnd);
}

LRESULT CNewpgenDlg::OnTrayMessage(UINT uID, LONG uMouseMsg)
{
	if (uID == 353)
	{
		if (uMouseMsg == WM_LBUTTONDBLCLK)
		{
			if (IsWindowVisible())
			{
				ShowWindow(SW_HIDE);
			}
			else
			{
				ShowWindow(SW_SHOWDEFAULT);
				SetForegroundWindow();
				TrayMessage(NIM_MODIFY, PRODUCTNAME);
			}
		}
	}

	return 0;
}


void CNewpgenDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CNewpgenDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CNewpgenDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CNewpgenDlg::OnRadioold() 
{
	// TODO: Add your control notification handler code here
	m_EditBase.EnableWindow (false);
	m_EditN.EnableWindow (false);
	m_EditKMin.EnableWindow (false);
	m_EditKMax.EnableWindow (false);
	m_EditCCLen.EnableWindow (false);
	m_StaticCCLen.ShowWindow (SW_HIDE);
	m_EditCCLen.ShowWindow (SW_HIDE);
	m_EditCCLen.SetWindowText ("");
	m_ComboType.EnableWindow (false);
	m_ComboType.SetCurSel (0);
	m_EditInFile.EnableWindow (true);
	m_ButtonFin.EnableWindow (true);

	m_EditBase.SetWindowText ("");
	m_EditN.SetWindowText ("");
	m_EditKMin.SetWindowText ("");
	m_EditKMax.SetWindowText ("");
	m_EditInFile.SetWindowText ("");
	m_RadioNew.SetCheck (0);
	m_CheckPrimorial.EnableWindow (false);
	m_CheckPrimorial.SetCheck (0);
	OnCheckprimorial();
	OnSelchangeCombo1 ();
	m_Generalized.EnableWindow (false);
	m_CheckEven.EnableWindow (false);
}


void CNewpgenDlg::OnRadionew() 
{
	// TODO: Add your control notification handler code here
	m_EditBase.EnableWindow (true);
	m_EditN.EnableWindow (true);
	m_EditKMin.EnableWindow (true);
	m_EditKMax.EnableWindow (true);
	m_EditCCLen.EnableWindow (true);
	m_StaticCCLen.ShowWindow (SW_HIDE);
	m_EditCCLen.ShowWindow (SW_HIDE);
	m_EditCCLen.SetWindowText ("");
	m_ComboType.EnableWindow (true);
	m_ComboType.SetCurSel (0);
	m_EditInFile.EnableWindow (false);
	m_ButtonFin.EnableWindow (false);
	m_EditBase.SetWindowText ("");
	m_EditN.SetWindowText ("");
	m_EditKMin.SetWindowText ("");
	m_EditKMax.SetWindowText ("");
	m_EditInFile.SetWindowText ("");
	m_RadioOld.SetCheck (0);
	m_CheckPrimorial.EnableWindow ();
	m_CheckPrimorial.SetCheck (0);
	OnCheckprimorial ();
	OnSelchangeCombo1 ();
	m_Generalized.EnableWindow ();
	m_CheckEven.EnableWindow ();
}


void CNewpgenDlg::OnSelchangeCombo1() 
{
	// TODO: Add your control notification handler code here
	char buff[1024];
	m_ComboType.GetWindowText (buff, 1024);
	if (buff[0] == '')
	{
		m_ComboType.SetCurSel (0);
		m_CheckPrimorial.SetCheck (!m_CheckPrimorial.GetCheck ());
	}
	OnCheckprimorial ();
}


void CNewpgenDlg::OnKillfocusEditcclen() 
{
	// TODO: Add your control notification handler code here
	
	char buff[1024];

	m_EditCCLen.GetWindowText (buff, 1024);
	if (atoi (buff) < 3)
	{
		m_EditCCLen.SetWindowText ("3");
	}
}

static char OldInFile[1024];
void CNewpgenDlg::OnSetfocusEditinfile() 
{
	// TODO: Add your control notification handler code here
	m_EditInFile.GetWindowText (OldInFile, 1024);
}

void CNewpgenDlg::OnKillfocusEditinfile() 
{
	// TODO: Add your control notification handler code here
	char NewInFile[1024];
	m_EditInFile.GetWindowText (NewInFile, 1024);

	if (_stricmp (NewInFile, OldInFile))
	{
		m_EditBase.SetWindowText ("");
		m_EditN.SetWindowText ("");
		m_EditKMin.SetWindowText ("");
		m_EditKMax.SetWindowText ("");
		OnCheckprimorial ();
	}
}

BOOL CNewpgenDlg::OnCopyData(CWnd* pWnd, COPYDATASTRUCT* pCopyDataStruct) 
{
	// TODO: Add your message handler code here and/or call default

	char *message = (char *)pCopyDataStruct->lpData;

	if (message[0] == '#')
	{
		// Control

		if (message[1] == '#') 	
		{
			// Finished stopping
			if (fAutoIncrement && State != 4)
			{
				// State = 4 ==> Stop button was pressed, or an error occurred.
				State = 0;
				if (fTest && fPFGW)	// fTest means under test, not in the released version.
				{
					if (State != 4 || AfxMessageBox ("The sieving was stopped before the Stop Criterion was reached. Do you want to send the data to PFGW anyway?", MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2) == IDYES)
					{
						// Call PFGW with the output file
						print ("\r\n*** SIEVING COMPLETE - CALLING PFGW...");

						char _PFGWParameters[100];
						strcpy (_PFGWParameters, PFGWParameters);

						char *args[50];
						args[0] = "PFGW";
						args[1] = outbuff;
						int argc = 2;

						args[argc++] = strtok (_PFGWParameters, " \t\n");

						while (args[argc-1] != NULL)
						{
							args[argc++] = strtok (NULL, " \t\n");
						}

						if (_spawnv (_P_WAIT, "PFGW", args) == -1)
						{
							print ("...failed!");

							return true;
						}
						else
						{
							print ("...succeeded");

							// Delete the output file in this case, otherwise
							// we will run out of hard disk space.
							remove (outbuff);
							strcat (outbuff, "~");
							remove (outbuff);
							outbuff[strlen (outbuff)-1] = '\0';
						}
					}
				}
				DoSieving (true);
			}
			else
			{
				WorkerThread = NULL;
				m_StartButton.SetWindowText ("&Start");
				TrayMessage(NIM_MODIFY, PRODUCTNAME);
				m_EditBase.SetReadOnly (false);
				m_EditN.SetReadOnly  (false);
				m_EditKMin.SetReadOnly (false);
				m_EditKMax.SetReadOnly  (false);
				m_EditCCLen.SetReadOnly (false);
				m_EditInFile.SetReadOnly (false);
				m_ButtonFout.EnableWindow (true);
				m_EditOutFile.SetReadOnly (false);
				GetMenu ()->EnableMenuItem (ID_OPTIONS_HIDE, MF_BYCOMMAND|MF_GRAYED);
				m_RadioOld.EnableWindow ();
				m_RadioNew.EnableWindow ();
				if (m_RadioNew.GetCheck ())
				{
					m_CheckPrimorial.EnableWindow ();
					m_ComboType.EnableWindow ();
					m_Generalized.EnableWindow ();
					m_CheckEven.EnableWindow ();
					m_ButtonFin.EnableWindow (false);
				}
				else
				{
					m_ButtonFin.EnableWindow (true);
				}
				OnCheckprimorial ();

				OnSelchangeCombo1 ();

				if (fPFGW)
				{
					if (State != 4 || AfxMessageBox ("The sieving was stopped before the Stop Criterion was reached. Do you want to send the data to PFGW anyway?", MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2) == IDYES)
					{
						// Call PFGW with the output file
						print ("\r\n*** SIEVING COMPLETE - CALLING PFGW...");

						char _PFGWParameters[100];
						strcpy (_PFGWParameters, PFGWParameters);

						char *args[50];
						args[0] = "PFGW";
						args[1] = outbuff;
						int argc = 2;

						args[argc++] = strtok (_PFGWParameters, " \t\n");

						while (args[argc-1] != NULL)
						{
							args[argc++] = strtok (NULL, " \t\n");
						}

						if (_spawnv (_P_NOWAIT, "PFGW", args) == -1)
						{
							print ("...failed!");
						}
						else
						{
							print ("...succeeded");
						}
					}
				}
				State = 0;
			}
		}
		else if (message[1] == 's') m_Status.SetWindowText (message+2);
		else if (message[1] == 'm') 
		{
			ShowWindow (SW_SHOWNORMAL);
			AfxMessageBox (message+2, MB_ICONEXCLAMATION);
		}
		else if (message[1] == 'o' && !fAutoIncrement && (!fPFGW || State == 4)) AfxMessageBox (message+2, MB_ICONEXCLAMATION);
		else if (message[1] == 't') TrayMessage(NIM_MODIFY, message+2);
		else if (message[1] == 'n') m_EditN.SetWindowText (message+2);
		else if (message[1] == 'r') m_StaticRate.SetWindowText (message+2);
		else if (message[1] == 'k') m_EditKMax.SetWindowText (message+2);
		else if (message[1] == 'l') m_EditKMin.SetWindowText (message+2);
		else if (message[1] == 'g') m_StaticOrig.SetWindowText (message+2);
	}
	else
	{
		int len = m_Edit.GetWindowTextLength();
		if (len >= 25000)
		{
			m_Edit.SetReadOnly (false);
			m_Edit.SetSel(0, 15000, true);
			m_Edit.Clear();
			m_Edit.SetReadOnly (true);
			len = m_Edit.GetWindowTextLength();
		}
		
		CString strTemp;
		if (len != 0)
			strTemp += _T("\r\n");
		strTemp += _T((TCHAR *)message);
		
		m_Edit.SetSel(len, len);
		m_Edit.ReplaceSel(strTemp);
	}
	return true; // CDialog::OnCopyData(pWnd, pCopyDataStruct);
}


void CNewpgenDlg::OnKillfocusEditbase() 
{
	// TODO: Add your control notification handler code here
	
	char buff[1024];

	m_EditBase.GetWindowText (buff, 1024);
	if (!buff[0]) return;
	if (atoi (buff) < 2)
	{
		m_EditBase.SetWindowText ("2");
	}
	OnCheckprimorial ();
}

void CNewpgenDlg::OnKillfocusEditn() 
{
	// TODO: Add your control notification handler code here
	
	char buff[1024];

	m_EditN.GetWindowText (buff, 1024);
	if (!buff[0]) return;

	if (strspn (buff, "0123456789*") != strlen (buff))
	{
		MessageBeep (0xFFFFFFFF);
		m_EditN.SetFocus ();
		m_EditN.SetWindowText ("");
	}
	else if (strchr (buff, '*'))
	{
		// No action, yet.
	}
	else if (_atoi64 (buff) != atoi (buff))
	{
		MessageBeep (0xFFFFFFFF);
		m_EditN.SetFocus ();
		m_EditN.SetWindowText ("");
		AfxMessageBox ("The value of n/k is too large. I think that the only time that such a large value would be entered here would be if you were doing a k.2^n sieve with k fixed. If that is the case, you can enter k by factorising it.\r\n\r\nE.g. instead of trying to enter a k value of '305892154425', you would enter '3*5*5*11*13*19*29*37*1399'.", MB_ICONEXCLAMATION);
	}
}

void CNewpgenDlg::OnKillfocusEditkmin() 
{
	// TODO: Add your control notification handler code here
	char buff[1024];

	if (m_RadioOld.GetCheck ()) return;

	m_EditKMin.GetWindowText (buff, 1024);
	if (!buff[0]) return;
	if (_atoi64 (buff) == 0 || _atoi64 (buff) == 1)
	{
		m_EditKMin.SetWindowText ("2");
	}
	if (_atoi64 (buff) < 0)
	{
		m_EditKMin.SetWindowText ("9223372036854775807");
	}
}

void getnewfilename (char *outbuff, int num, char *inbuff)
{
	// Prepend '<num>_' at the start of the file name, but handle directories.

	char *slash = strrchr (inbuff, '\\');

	if (slash)
	{
		strncpy (outbuff, inbuff, (slash+1)-inbuff);
		outbuff[(slash+1)-inbuff] = '\0';
		slash++;
	}
	else
	{
		slash = inbuff;
		outbuff[0] = '\0';
	}
	sprintf (outbuff+strlen (outbuff), "%d_", num);
	strcat (outbuff, slash);

}

void CNewpgenDlg::OnKillfocusEditkmax() 
{
	// TODO: Add your control notification handler code here
	char buff[1024];

	m_EditKMax.GetWindowText (buff, 1024);
	if (!buff[0]) return;
	if (_atoi64 (buff) == 0)
	{
		m_EditKMax.SetWindowText ("1");
	}
	if (_atoi64 (buff) < 0)
	{
		m_EditKMax.SetWindowText ("9223372036854775807");
	}
}


void CNewpgenDlg::DoSieving (bool fDoingAutoIncrement)
{
	// TODO: Add your control notification handler code here
	UpdateData (false);
	char buff[1024];

	fMyPrimorial = false;

	// Test that we have got everything first....

	if (m_RadioOld.GetCheck ())
	{
		// If Autoincrement????
		// Decision... it works, power users will discover this.
		// What would you want autoincrement mode to do if you were continuing???

		m_EditInFile.GetWindowText (OldInFile, 1024);
		m_EditInFile.GetWindowText (buff, 1024);
		if (buff[0] == 0)
		{
			MessageBeep (0xFFFFFFFF);
			m_EditInFile.SetFocus ();
			return;
		}

		m_EditOutFile.GetWindowText (outbuff, 1024);

		if (!outbuff[0]) 
		{
			MessageBeep (0xFFFFFFFF);
			m_EditOutFile.SetFocus ();
			return;
		}

		m_StartButton.EnableWindow (false);
		bool bReadOK = readinfile (buff);
		m_StartButton.EnableWindow (true);

		// Test the output file.
		FILE *fptr = fopen (outbuff, "r");
		if (fptr)
		{
			// Already exists...
			fclose (fptr);

			if (!fDoingAutoIncrement)
			{
				char errbuff[1024];

				if (TwoSaveFiles)
				{
					sprintf (errbuff, "The output file %s already exists - shall I save its contents to %s~?", outbuff, outbuff);
					DontShowMeYNC dlg (errbuff, &DSM_DSMYNC);
					dlg.DoModal ();
					if (dlg.m_Button == IDCANCEL)
					{
						m_EditOutFile.SetFocus ();
						return;
					}
					else if (dlg.m_Button == IDYES)
					{
						char newname[10240];
						sprintf (newname, "%s~", outbuff);

						remove (newname);
						rename (outbuff, newname);
					}
				}
				else
				{
					sprintf (errbuff, "The output file %s already exists - continue?", outbuff);
					if (AfxMessageBox (errbuff, MB_ICONQUESTION|MB_OKCANCEL|MB_DEFBUTTON2) != IDOK)
					{
						m_EditOutFile.SetFocus ();
						return;
					}
				}
			}
		}

		fptr = fopen (outbuff, "w");
		if (!fptr)
		{
			// Cannot write
			AfxMessageBox ("The output file could not be opened.", MB_ICONEXCLAMATION);
			m_EditOutFile.SetFocus ();
			return;
		}
		fclose (fptr);
		remove (outbuff);

		if (bReadOK)
		{
			char buff[10240];

			if (!fMyPrimorial && (mode & MODE_PRIMORIAL))
			{
				m_EditBase.SetWindowText ("");
			}
			else
			{
				sprintf (buff, "%d", base);
				m_EditBase.SetWindowText (buff);
			}

			if (mode == MODE_LP || mode == MODE_LM)
			{
				// Increment n - it was an old file that we were sieving,
				// and readfile() will have decremented it.
				// DoSieve() will decrement it again.
				nvalue++;
			}

			if (fMyPrimorial)
			{
				buff[0] = 0;

				for (unsigned int i = 0; i < nMyPrimorial; i++)
				{
					char buff1[20];

					sprintf (buff1, "%I64d*", MyPrimorial[i]);
					strcat (buff, buff1);
				}
				buff[strlen (buff) - 1] = 0;
			}
			else
			{
				sprintf (buff, "%d", nvalue);
			}
			m_EditN.SetWindowText (buff);
			sprintf (buff, "%I64d", MinNum);
			m_EditKMin.SetWindowText (buff);
			sprintf (buff, "%I64d", MaxNum);
			m_EditKMax.SetWindowText (buff);

			if (!fMyPrimorial && (mode & MODE_PRIMORIAL))
			{
				m_CheckPrimorial.SetCheck (1);
				OnCheckprimorial ();						
			}

			if (mode & MODE_NOTGENERALISED)
			{
				m_Generalized.SetCheck (0);
			}
			else
			{
				m_Generalized.SetCheck (1);
			}

			if (mode & MODE_EVENKS)
			{
				m_Generalized.SetCheck (1);
			}
			else
			{
				m_Generalized.SetCheck (0);
			}

			switch (mode & ~(MODE_PRIMORIAL | MODE_EVENKS | MODE_NOTGENERALISED | MODE_MOREHEAD))
			{
			case MODE_PLUS:
				m_ComboType.SetCurSel (0);
				break;
			case MODE_MINUS:
				m_ComboType.SetCurSel (1);
				break;
			case MODE_TWIN:
				m_ComboType.SetCurSel (2);
				break;
			case MODE_SG:
				m_ComboType.SetCurSel (3);
				break;
			case MODE_CC:
				m_ComboType.SetCurSel (4);
				break;
			case MODE_BI:
				m_ComboType.SetCurSel (5);
				break;
			case MODE_IJ:
				m_ComboType.SetCurSel (6);
				break;
			case MODE_IJ2:
				m_ComboType.SetCurSel (7);
				break;
			case MODE_LP:
				m_ComboType.SetCurSel (8);
				break;
			case MODE_LM:
				m_ComboType.SetCurSel (9);
				break;
			case MODE_CC13:
				m_ComboType.SetCurSel (10);
				break;
			case MODE_CC23:
				m_ComboType.SetCurSel (11);
				break;
			case MODE_BI3:
				m_ComboType.SetCurSel (12);
				break;
			case MODE_AP:
				m_ComboType.SetCurSel (13);
				break;
			case MODE_3TUPLE:
				m_ComboType.SetCurSel (14);
				break;
			case MODE_4TUPLE:
				m_ComboType.SetCurSel (15);
				break;
			case MODE_PLUSKSIEVE:
				m_ComboType.SetCurSel (16);
				break;
			case MODE_MINUSKSIEVE:
				m_ComboType.SetCurSel (17);
				break;
			case MODE_SG3:
				m_ComboType.SetCurSel (18);
				break;
			case MODE_PLUSDUAL:
				m_ComboType.SetCurSel (19);
				break;
			case MODE_MINUSDUAL:
				m_ComboType.SetCurSel (20);
				break;


			}
			if ((m_ComboType.GetCurSel () == 16 || m_ComboType.GetCurSel () == 17 || m_ComboType.GetCurSel () == 19 || m_ComboType.GetCurSel () == 20) && !m_CheckPrimorial.GetCheck ())
			{
				m_StaticN.SetWindowText ("&k:");
				m_StaticKMin.SetWindowText ("&nmin:");
				m_StaticKMax.SetWindowText ("nma&x:");
			}
			else
			{
				m_StaticN.SetWindowText ("&n:");
				m_StaticKMin.SetWindowText ("&kmin:");
				m_StaticKMax.SetWindowText ("kma&x:");
			}

			if (m_ComboType.GetCurSel () >= 10 && m_ComboType.GetCurSel () <= 12)
			{
				sprintf (buff, "%d", len3plus);
				m_StaticCCLen.ShowWindow (SW_SHOW);
				m_EditCCLen.ShowWindow (SW_SHOW);
				m_EditCCLen.SetWindowText (buff);
			}
			else
			{
				m_StaticCCLen.ShowWindow (SW_HIDE);
				m_EditCCLen.ShowWindow (SW_HIDE);
				m_EditCCLen.SetWindowText ("");
			}
			if (mode & MODE_NOTGENERALISED)
			{
				m_Generalized.SetCheck (0);
			}
			else
			{
				m_Generalized.SetCheck (1);
			}
			if (mode & MODE_EVENKS)
			{
				m_CheckEven.SetCheck (1);
			}
			else
			{
				m_CheckEven.SetCheck (0);
			}
			OnCheckprimorial ();
		}
		else
		{
			ShowWindow (SW_SHOWNORMAL);
			MessageBeep (0xFFFFFFFF);
			m_EditInFile.SetFocus ();
			return;
		}

		m_StartButton.SetWindowText ("&Start");
		fGenerateFile = false;
		m_EditBase.EnableWindow (false);
		m_EditN.EnableWindow (false);
		m_EditKMin.EnableWindow (false);
		m_EditKMax.EnableWindow (false);
		m_EditCCLen.EnableWindow (false);
		m_ComboType.EnableWindow (false);
		m_Generalized.EnableWindow (false);
		m_CheckEven.EnableWindow (false);
	}
	else
	{
		fGenerateFile = true;

		m_EditOutFile.GetWindowText (outbuff, 1024);

		if (!outbuff[0]) 
		{
			MessageBeep (0xFFFFFFFF);
			m_EditOutFile.SetFocus ();
			return;
		}

		if (m_CheckPrimorial.GetCheck ())
		{
			base = 2;
		}
		else
		{
			m_EditBase.GetWindowText (buff, 1024);
			if (!buff[0]) 
			{
				MessageBeep (0xFFFFFFFF);
				m_EditBase.SetFocus ();
				return;
			}
			base = atoi (buff);
		}
		
		mode = m_CheckPrimorial.GetCheck () ? MODE_PRIMORIAL : 0;

		if (HandleGeneralized ())
		{
			mode |= MODE_NOTGENERALISED;
		}

		if (HandleEven ())
		{
			mode |= MODE_EVENKS;
		}

		switch (m_ComboType.GetCurSel ())
		{
		case 0: 
			mode |= MODE_PLUS;
			break;
		case 1:
			mode |= MODE_MINUS;
			break;
		case 2:
			mode |= MODE_TWIN;
			break;
		case 3:
			mode |= MODE_SG;
			break;
		case 4:
			mode |= MODE_CC;
			break;
		case 5:
			mode |= MODE_BI;
			break;
		case 6:
			mode |= MODE_IJ;
			break;
		case 7:
			mode |= MODE_IJ2;
			break;
		case 8:
			mode |= MODE_LP;
			break;
		case 9:
			mode |= MODE_LM;
			break;
		case 10:
			mode |= MODE_CC13;
			break;
		case 11:
			mode |= MODE_CC23;
			break;
		case 12:
			mode |= MODE_BI3;
			break;
		case 13:
			mode |= MODE_AP;
			break;
		case 14:
			mode |= MODE_3TUPLE;
			break;
		case 15:
			mode |= MODE_4TUPLE;
			break;
		case 16:
			mode |= MODE_PLUSKSIEVE;
			break;
		case 17:
			mode |= MODE_MINUSKSIEVE;
			break;
		case 18:
			mode |= MODE_SG3;
			break;
		case 19:
			mode |= MODE_PLUSDUAL;
			break;
		case 20:
			mode |= MODE_MINUSDUAL;
			break;
		}

		m_EditN.GetWindowText (buff, 1024);
		if (!buff[0] || atoi (buff) == 0)
		{
			MessageBeep (0xFFFFFFFF);
			m_EditN.SetFocus ();
			return;
		}

		if (strchr (buff, '*'))
		{
			// This ought to be a k.2^n fixed k sieve.
			if (base != 2 || !(mode & MODE_KSIEVE) || (mode & MODE_PRIMORIAL))
			{
				MessageBeep (0xFFFFFFFF);
				m_EditN.SetFocus ();
				return;
			}
			// OK, get the values into my array
			fMyPrimorial = true;
			nvalue = 1;
			char *x = buff;
			__int64 *MyPrimorialptr = MyPrimorial;

			do
			{
				*MyPrimorialptr++ = _atoi64 (x);
				x = strchr (x, '*');
				if (x) x++;
			} while (x);

			nMyPrimorial = MyPrimorialptr - MyPrimorial;
			mode |= MODE_PRIMORIAL;
		}
		else
		{
			nvalue = atoi (buff);
		}
		if ((mode & (MODE_KSIEVE|MODE_DUAL)) && !(mode & MODE_PRIMORIAL) && (nvalue & 1) && (base & 1))
		{
			if (nvalue & 1)
			{
				AfxMessageBox ("k ought to be even for that fixed k sieve.\r\n", MB_ICONEXCLAMATION);
			}
			m_EditN.SetFocus ();
			return;
		}
		if (fDoingAutoIncrement)
		{
			bool TimeToStopSieving = false;

			if (mode & MODE_PRIMORIAL)
			{
				// Move up to the next prime number.
				// Unless we have got to the top, of course.
				int i = 0;
				while (nvalue > primetable[i]) i++;

				if (i+AutoIncrementAmount < PRIMETABLELEN)
				{
					nvalue = primetable[i+AutoIncrementAmount];
				}
				else
				{
					TimeToStopSieving = true;
				}
			}
			else
			{
				nvalue+=AutoIncrementAmount;
				if ((mode & MODE_KSIEVE) && !(mode & MODE_PRIMORIAL) && !(nvalue & 1)) nvalue++;
			}

			if (MaxN && nvalue > MaxN)
			{
				TimeToStopSieving = true;
			}

			if (TimeToStopSieving)
			{
				WorkerThread = NULL;
				m_StartButton.SetWindowText ("&Start");
				m_EditBase.SetReadOnly (false);
				m_EditN.SetReadOnly  (false);
				m_EditKMin.SetReadOnly (false);
				m_EditKMax.SetReadOnly  (false);
				m_EditCCLen.SetReadOnly (false);
				m_EditInFile.SetReadOnly (false);
				m_ButtonFout.EnableWindow (true);
				m_EditOutFile.SetReadOnly (false);
				m_RadioOld.EnableWindow ();
				m_RadioNew.EnableWindow ();
				if (m_RadioNew.GetCheck ())
				{
					m_ButtonFin.EnableWindow (false);
					m_CheckPrimorial.EnableWindow ();
					m_ComboType.EnableWindow ();
				}
				else
				{
					m_ButtonFin.EnableWindow (true);
				}

				AfxMessageBox ("The sieve limit has been reached");
				State = 0;
				GetMenu ()->EnableMenuItem (ID_OPTIONS_HIDE, MF_BYCOMMAND|MF_GRAYED);
				return;
			}
			sprintf (buff, "%d", nvalue);
			m_EditN.SetWindowText (buff);
		}

		if (mode & MODE_PRIMORIAL && !fMyPrimorial)
		{
			if (nvalue > MAXPRIMORIAL)
			{
				char buff[1024];
				sprintf (buff, "The maximum value for a primorial is %d# -\r\nwhich has got about %d decimal digits!\r\n", MAXPRIMORIAL, (int)(MAXPRIMORIAL/2.302585));
				AfxMessageBox (buff, MB_ICONEXCLAMATION);
				if ((rand () % 5) == 2)
				{
					// Here's the easter egg!
					// I could have put up a 3d game... but that would have been needless software bloat.
					// Instead I will just throw up a few daft message boxes.
					Sleep (1000);
					AfxMessageBox ("Don't curse *me*, blame the idiot who wrote me!", MB_ICONEXCLAMATION);
					Sleep (2000);
					AfxMessageBox ("Actually, now you have got me into this particular bit of code, it all comes flooding back.\r\nAah, those sweet memories of long debugging sessions into the night...\r\n", MB_ICONEXCLAMATION);
				}
				m_EditN.SetFocus ();
				return;
			}
			else
			{
				// Find the largest prime >= nvalue, and set nvalue to that.
				int i = 0;
				while (nvalue >= primetable[i])  i++;
				nvalue = primetable[i-1];
				sprintf (buff, "%d", nvalue);
				m_EditN.SetWindowText (buff);
			}
		}
		if ((mode == MODE_3TUPLE || mode == MODE_4TUPLE) && (base%5) == 0)
		{
			char buff[1024];
			sprintf (buff, "5 will always divide k.%d^n+5 - choose a different base.\r\n", base);
			AfxMessageBox (buff, MB_ICONEXCLAMATION);
			m_EditBase.SetFocus ();
			return;
		}
		if (mode == MODE_4TUPLE && (base%7) == 0)
		{
			char buff[1024];
			sprintf (buff, "7 will always divide k.%d^n+7 - choose a different base.\r\n", base);
			AfxMessageBox (buff, MB_ICONEXCLAMATION);
			m_EditBase.SetFocus ();
			return;
		}
		if ((mode == MODE_SG3) && (base%3) == 0)
		{
			char buff[1024];
			sprintf (buff, "3 will always divide 2k.%d^n+3 - choose a different base.\r\n", base);
			AfxMessageBox (buff, MB_ICONEXCLAMATION);
			m_EditBase.SetFocus ();
			return;
		}
		if ((mode & MODE_KSIEVE) && !(mode & MODE_PRIMORIAL) && (mode & MODE_DUAL) && base != 2)
		{
			AfxMessageBox ("The fixed k 2^n+k sieves only work with base 2 at the moment.\r\n", MB_ICONEXCLAMATION);
			m_EditBase.SetFocus ();
			return;
		}
		if ((mode & MODE_KSIEVE) && !(mode & MODE_PRIMORIAL) && !(mode & MODE_DUAL) && base > 255255)
		{
			AfxMessageBox ("The fixed k sieves requires the base to be <= 255255 at the moment.\r\n", MB_ICONEXCLAMATION);
			m_EditBase.SetFocus ();
			return;
		}

		static __int64 SaveMinNum, SaveMaxNum;

		if (!fDoingAutoIncrement)
		{
			m_EditKMin.GetWindowText (buff, 1024);
			if (!buff[0] || atoi (buff) == 0) 
			{
				MessageBeep (0xFFFFFFFF);
				m_EditKMin.SetFocus ();
				return;
			}
			MinNum = _atoi64 (buff);

			m_EditKMax.GetWindowText (buff, 1024);
			if (!buff[0] || atoi (buff) == 0)
			{
				MessageBeep (0xFFFFFFFF);
				m_EditKMax.SetFocus ();
				return;
			}
				
			MaxNum = _atoi64 (buff);

			if (MaxNum < MinNum)
			{
				MessageBeep (0xFFFFFFFF);
				m_EditKMax.SetFocus ();
				return;
			}
			
			if (MaxNum - MinNum > BitMapThreshold)
			{
				char buff[1024];
				sprintf (buff, "The range of k that you have specified (%I64d) is too large to fit into the bitmap, which can hold %I64d k's.\nThis is not too much of a problem, as NewPGen will break this up into %d smaller ranges and sieve each in turn up to 1 billion before combining them and sieving together.\nHowever, you might like to consider increasing the bitmap size. Do you wish to continue?", 1+MaxNum-MinNum, BitMapThreshold, (int)(1+(1+MaxNum-MinNum)/BitMapThreshold));
				if (AfxMessageBox (buff, MB_ICONQUESTION|MB_OKCANCEL|MB_DEFBUTTON2) != IDOK)
				{
					return;
				}
			}

			SaveMinNum = MinNum;
			SaveMaxNum = MaxNum;
		}
		else
		{
			MinNum = SaveMinNum;
			MaxNum = SaveMaxNum;

			char buff[1024];
			sprintf (buff, "%I64d", MinNum);
			m_EditKMin.SetWindowText (buff);

			sprintf (buff, "%I64d", MaxNum);
			m_EditKMax.SetWindowText (buff);
		}

		if (m_ComboType.GetCurSel () >= 10 && m_ComboType.GetCurSel () <= 12)
		{
			m_EditCCLen.GetWindowText (buff, 1024);
			if (atoi (buff) < 3)
			{
				MessageBeep (0xFFFFFFFF);
				m_EditCCLen.SetFocus ();
				return;
			}
			len3plus = atoi (buff);
		}

		// Test the output file.
		FILE *fptr = fopen (outbuff, "r");
		if (fptr)
		{
			// Already exists...
			fclose (fptr);

			if (!fDoingAutoIncrement)
			{
				char errbuff[1024];

				if (TwoSaveFiles)
				{
					sprintf (errbuff, "The output file %s already exists - shall I save its contents to %s~?", outbuff, outbuff);
					DontShowMeYNC dlg (errbuff, &DSM_DSMYNC);
					dlg.DoModal ();
					if (dlg.m_Button == IDCANCEL)
					{
						m_EditOutFile.SetFocus ();
						return;
					}
					else if (dlg.m_Button == IDYES)
					{
						char newname[10240];
						sprintf (newname, "%s~", outbuff);

						remove (newname);
						rename (outbuff, newname);
					}
				}
				else
				{
					sprintf (errbuff, "The output file %s already exists - continue?", outbuff);
					if (AfxMessageBox (errbuff, MB_ICONQUESTION|MB_OKCANCEL|MB_DEFBUTTON2) != IDOK)
					{
						m_EditOutFile.SetFocus ();
						return;
					}
				}
			}
		}
	}


	if (!fDoingAutoIncrement && fAutoIncrement)
	{
		char errbuff[1024];
		if (MaxN && nvalue > MaxN)
		{
			sprintf (errbuff, "You have indicated that %c should be incremented up to %d, but the starting value of %d is less than this!", (mode & (MODE_KSIEVE|MODE_DUAL)) ? 'k' : 'n', MaxN, nvalue);
			AfxMessageBox (errbuff, MB_ICONEXCLAMATION);
			return;
		}
		if (mode & (MODE_KSIEVE|MODE_DUAL))
		{
			char newfile1[1024], newfile2[1024];

			getnewfilename (newfile1, nvalue, outbuff);
			getnewfilename (newfile2, nvalue+2, outbuff);

			sprintf (errbuff, "The autoincrement 'k' flag is set.\r\nThis means that once this range has been sieved, 'k' will be incremented and the sieving will start again.\r\nThe output files will be called %s, %s, etc - is this okay?", newfile1, newfile2);
		}
		else
		{
			int nextn;

			if (mode & MODE_PRIMORIAL)
			{
				// Find the next prime number.
				int i = 0;
				while (nvalue > primetable[i]) i++;

				if (i+AutoIncrementAmount < PRIMETABLELEN)
				{
					nextn = primetable[i+AutoIncrementAmount];
				}
				else
				{
					// No need to bother searching.
					// This might look plausible!
					nextn = MAXPRIMORIAL+4;
				}
			}
			else 
			{
				nextn = nvalue + AutoIncrementAmount;
				if ((mode & (MODE_KSIEVE|MODE_DUAL)) && !(nextn & 1)) 
				{
					nextn++;
				}
			}

			char newfile1[1024], newfile2[1024];

			getnewfilename (newfile1, nvalue, outbuff);
			getnewfilename (newfile2, nextn, outbuff);

			sprintf (errbuff, "The autoincrement 'n' flag is set.\r\nThis means that once this range has been sieved, 'n' will be incremented and the sieving will start again.\r\nThe output files will be called %s, %s, etc - is this okay?", newfile1, newfile2);
		}
		if (AfxMessageBox (errbuff, MB_ICONQUESTION|MB_OKCANCEL|MB_DEFBUTTON2) != IDOK)
		{
			return;
		}
	}

	if (fAutoIncrement)
	{
		char newfile[1024];
		getnewfilename (newfile, nvalue, outbuff);
		strcpy (outbuff, newfile);
	}

	if (!fAutoIncrement && StopCriterion != NONE)
	{
		char errbuff[1024], errbuff1[1024];

		if (StopCriterion == MAXP)
		{
			sprintf (errbuff, "Sieve up to p = %I64d", StopValue);
		}
		else if (StopCriterion == DATETIME)
		{
			sprintf (errbuff, "Sieve for %I64d hours", StopValue);
		}
		else if (StopCriterion == RATE)
		{
			sprintf (errbuff, "Sieve until %c's are being removed every %.1f seconds", (mode & (MODE_KSIEVE|MODE_DUAL)) ? 'n' : 'k', (__int64)StopValue/10.0);
		}
		else if (StopCriterion == KSREMAINING)
		{
			sprintf (errbuff, "Sieve until fewer than %I64d k's remain", StopValue);
		}
		
		if (fPFGW) strcat (errbuff, ", then automatically send the results to PFGW");

		sprintf (errbuff1, "There is a stop criterion for this sieve:\r\n\r\n%s.\r\n\r\nDo you want to continue?", errbuff);
		if (AfxMessageBox (errbuff1, MB_ICONQUESTION|MB_OKCANCEL|MB_DEFBUTTON2) != IDOK)
		{
			return;
		}
	}
	if (!fAutoIncrement && base == 2 && nvalue == 3 && (mode == MODE_PLUSKSIEVE))
	{
		if (AfxMessageBox ("You are sieving 3.2^n+1. Are you looking for a divisor of a Fermat number? \r\n(If you are then I will ignore even values of n, as these can never divide a Fermat number by Morehead's Theorem)", MB_YESNO) == IDYES)
		{
			mode |= MODE_MOREHEAD;
		}
	}
	if (!fAutoIncrement && base == 2 && nvalue == 9 && (mode == MODE_PLUSKSIEVE))
	{
		if (AfxMessageBox ("You are sieving 9.2^n+1. Are you looking for a divisor of a Fermat number? \r\n(If you are then I will ignore even values of n, as these can never divide a Fermat number)", MB_YESNO) == IDYES)
		{
			mode |= MODE_MOREHEAD;
		}
	}

	// The very last thing we do is to see if the output file can be written.
	FILE *fptr = fopen (outbuff, "w");
	if (!fptr)
	{
		// Cannot write
		AfxMessageBox ("The output file could not be opened.", MB_ICONEXCLAMATION);
		m_EditOutFile.SetFocus ();
		return;
	}
	fclose (fptr);
	remove (outbuff);

	// Write out the ini file, just to be on the safe side.
	WriteIniFile ();

	// Let's go!
	WorkerThread = AfxBeginThread(SieveFile, 
								&fGenerateFile, 
								(GetMenu ()->GetMenuState (ID_OPTION_WORKERTHREADPRIORITY_LOWEST, MF_BYCOMMAND) & MF_CHECKED)
										? THREAD_PRIORITY_IDLE
										: THREAD_PRIORITY_NORMAL);

	m_StartButton.SetWindowText ("&Stop");
	m_StaticRate.SetWindowText ("");
	m_Status.SetWindowText ("");
	m_EditBase.SetReadOnly ();
	m_EditN.SetReadOnly  ();
	m_EditKMin.SetReadOnly ();
	m_EditKMax.SetReadOnly ();
	m_EditCCLen.SetReadOnly ();
	m_EditInFile.SetReadOnly ();
	m_ButtonFin.EnableWindow (false);
	m_ButtonFout.EnableWindow (false);
	m_EditOutFile.SetReadOnly ();
	m_RadioOld.EnableWindow (false);
	m_RadioNew.EnableWindow (false);
	m_ComboType.EnableWindow (false);
	m_CheckPrimorial.EnableWindow (false);
	m_Generalized.EnableWindow (false);
	m_CheckEven.EnableWindow (false);
	GetMenu ()->EnableMenuItem (ID_OPTIONS_HIDE, MF_BYCOMMAND|MF_ENABLED);
}

void CNewpgenDlg::OnStart() 
{
	// TODO: Add your control notification handler code here
	UpdateData (false);

	if (State == 0)
	{
		DoSieving (false);
	}
	else
	{
		GetMenu()->CheckMenuItem (ID_OPTIONS_AUTOMATICALLYCONTINUESIEVINGTHELASTFILEONSTARTUP, MF_BYCOMMAND | MF_UNCHECKED);
		if (State == 1)
		{
			State = 4;
		}
		else if (State == 2)
		{
			State = 4;
			m_StartButton.SetWindowText ("&Stopping");
		}
		else
		{
			// State == 4
		}
	}
}

void CNewpgenDlg::OnFileExit() 
{
	// TODO: Add your command handler code here
	OnCommand (WM_DESTROY, 0);
}

void CNewpgenDlg::OnMAbout() 
{
	// TODO: Add your command handler code here
	CAboutDlg dlg;
	dlg.DoModal();
}

void CNewpgenDlg::OnMContents() 
{
	// TODO: Add your command handler code here
	CContents dlg;
	dlg.DoModal ();
}

void CNewpgenDlg::OnHelpWhatsnewinthisrelease() 
{
	// TODO: Add your command handler code here
	CContents dlg (true);
	dlg.DoModal ();
}

void CNewpgenDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	if (nType == SIZE_MINIMIZED && GetMenu ()->GetMenuState (ID_OPTION_TRAYICON, MF_BYCOMMAND) & MF_CHECKED)
	{
		ShowWindow (SW_HIDE);
	}
}

void CNewpgenDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
	TrayMessage(NIM_DELETE, PRODUCTNAME);
}

BOOL CNewpgenDlg::OnCommand(WPARAM wParam, LPARAM lParam) 
{
	// TODO: Add your specialized code here and/or call the base class
	if (wParam == WM_DESTROY && State)
	{
		if (!IsWindowVisible())
		{
			ShowWindow(SW_SHOWDEFAULT);
			SetForegroundWindow();
			TrayMessage(NIM_MODIFY, PRODUCTNAME);
		}

		if (AfxMessageBox ("The sieve is still running - are you sure you wish to exit without saving?\n(To save, press the 'Stop' button, then close NewPGen down)",MB_ICONQUESTION|MB_OKCANCEL|MB_DEFBUTTON2) == IDOK)
		{
			DestroyWindow ();
		}
		return true;
	}
	if (wParam == WM_DESTROY)
	{
		WriteIniFile ();

		DestroyWindow ();
		return true;
	}
	return CDialog::OnCommand(wParam, lParam);
}

void CNewpgenDlg::WriteIniFile ()
{
	FILE *fptr = fopen ("NewPGen.ini", "w");

	if (fptr)
	{
		fprintf (fptr, "TrayIcon = %d\n", (GetMenu ()->GetMenuState (ID_OPTION_TRAYICON, MF_BYCOMMAND) & MF_CHECKED) ? 1 : 0);
		fprintf (fptr, "WorkerThreadPriorityLowest = %d\n", (GetMenu ()->GetMenuState (ID_OPTION_WORKERTHREADPRIORITY_LOWEST, MF_BYCOMMAND) & MF_CHECKED) ? 1 : 0);
		fprintf (fptr, "Priority = %s\n", m_PIdle.GetCheck () ? "Idle" : m_PHigh.GetCheck () ? "High" : "Normal");
		fprintf (fptr, "BitmapThreshold = %I64d\n", BitMapThreshold);
		fprintf (fptr, "MinutesBetweenWrites = %d\n", WriteIterations);
		fprintf (fptr, "DSM_TwoSaveFiles = %d\n", DSM_TwoSaveFiles ? 1 : 0);
		fprintf (fptr, "DSM_AlwaysSave = %d\n", DSM_DSMYNC ? 1 : 0);
		fprintf (fptr, "TwoSaveFiles = %d\n", TwoSaveFiles ? 1 : 0);
		fprintf (fptr, "DSM_LogDeleted = %d\n", DSM_LogDeleted ? 1 : 0);
		if (GetMenu ()->GetMenuState (ID_OPTIONS_AUTOMATICALLYCONTINUESIEVINGTHELASTFILEONSTARTUP, MF_BYCOMMAND) & MF_CHECKED)
		{
			char buff[1024];

			m_EditOutFile.GetWindowText (buff, 1024);

			if (buff[0])
			{
				fprintf (fptr, "InputFileName = %s\n", buff);
			}
		}
		if (fTest) fprintf (fptr, "PJTEST = 1\n");

		if (fAutoStartHidden)
		{
			fprintf (fptr, "Hidden = 1\n");
		}
	}
	fclose (fptr);
}
void CNewpgenDlg::OnRadiophigh() 
{
	// TODO: Add your control notification handler code here
	m_PIdle.SetCheck (0);
	m_PNormal.SetCheck (0);

	SetPriorityClass (GetCurrentProcess (), HIGH_PRIORITY_CLASS);
	SetThreadPriority (GetCurrentThread (), THREAD_PRIORITY_HIGHEST);
}

void CNewpgenDlg::OnRadiopidle() 
{
	// TODO: Add your control notification handler code here
	m_PHigh.SetCheck (0);
	m_PNormal.SetCheck (0);
	
	SetPriorityClass (GetCurrentProcess (), IDLE_PRIORITY_CLASS);
	SetThreadPriority (GetCurrentThread (), THREAD_PRIORITY_IDLE);
}

void CNewpgenDlg::OnRadiopnormal() 
{
	// TODO: Add your control notification handler code here
	m_PHigh.SetCheck (0);
	m_PIdle.SetCheck (0);
	
	SetPriorityClass (GetCurrentProcess (), NORMAL_PRIORITY_CLASS);
	SetThreadPriority (GetCurrentThread (), THREAD_PRIORITY_NORMAL);
}

void CNewpgenDlg::OnOptionTrayicon() 
{
	// TODO: Add your command handler code here
	if (GetMenu ()->GetMenuState (ID_OPTION_TRAYICON, MF_BYCOMMAND) & MF_CHECKED)
	{
		GetMenu()->CheckMenuItem (ID_OPTION_TRAYICON, MF_BYCOMMAND | MF_UNCHECKED);
		TrayMessage(NIM_DELETE, PRODUCTNAME);
	}
	else
	{
		GetMenu()->CheckMenuItem (ID_OPTION_TRAYICON, MF_BYCOMMAND | MF_CHECKED);
		TrayMessage(NIM_ADD, PRODUCTNAME);
	}
	WriteIniFile ();
}

void CNewpgenDlg::OnOptionWorkerthreadpriorityLowest() 
{
	// TODO: Add your command handler code here
	GetMenu()->CheckMenuItem (ID_OPTION_WORKERTHREADPRIORITY_LOWEST, MF_BYCOMMAND | MF_CHECKED);
	GetMenu()->CheckMenuItem (ID_OPTION_WORKERTHREADPRIORITY_NORMAL, MF_BYCOMMAND | MF_UNCHECKED);
	if (WorkerThread)
	{
		WorkerThread->SetThreadPriority (THREAD_PRIORITY_IDLE);
	}
}

void CNewpgenDlg::OnOptionWorkerthreadpriorityNormal() 
{
	// TODO: Add your command handler code here
	GetMenu()->CheckMenuItem (ID_OPTION_WORKERTHREADPRIORITY_LOWEST, MF_BYCOMMAND | MF_UNCHECKED);
	GetMenu()->CheckMenuItem (ID_OPTION_WORKERTHREADPRIORITY_NORMAL, MF_BYCOMMAND | MF_CHECKED);
	if (WorkerThread)
	{
		WorkerThread->SetThreadPriority (THREAD_PRIORITY_NORMAL);
	}
}


void CNewpgenDlg::OnOptionsHide() 
{
	if (GetMenu ()->GetMenuState (ID_OPTIONS_AUTOMATICALLYCONTINUESIEVINGTHELASTFILEONSTARTUP, MF_BYCOMMAND) & MF_CHECKED)
	{
		// Autostart is set. We had better tell the user what to do!

		if (AfxMessageBox ("NewPGen is going to be hidden!\nYou will be unable to activate NewPGen once you validate this command - it will be visible on the Task Manager only.\nIf you do this, it is recommended that you have some sort of 'Sieve Until' option set.\n\nYou are also automatically sieving the last file on startup, so when NewPGen is restarted it will remain hidden and continue sieving this file. To make NewPGen visible again, you will have to:\n\n1. Edit NewPGen.ini\n2. Delete the line that says 'Hidden = 1'\n3. Stop NewPGen (using the Task Manager), then restart it.\n\nDo you really want to continue?", 
								MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2) == IDNO)
		{
			return;
		}
	}
	else	if (AfxMessageBox ("NewPGen is going to be hidden!\nYou will be unable to activate NewPGen once you validate this command - it will be visible on the Task Manager only.\nIf you do this, it is recommended that you have some sort of 'Sieve Until' option set.\nDo you really want to continue?", 
							MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2) == IDNO)
	{
		return;
	}

	fAutoStartHidden = true;

	WriteIniFile ();

	if (GetMenu ()->GetMenuState (ID_OPTION_TRAYICON, MF_BYCOMMAND) & MF_CHECKED)
	{
		TrayMessage(NIM_DELETE, PRODUCTNAME);
	}
	ShowWindow (SW_HIDE);
}

void CNewpgenDlg::OnCheckprimorial() 
{
	// TODO: Add your control notification handler code here
	bool fNotGeneralized = HandleGeneralized ();
	bool fEven = HandleEven ();

	if (m_CheckPrimorial.GetCheck ())
	{
		if (m_RadioNew.GetCheck ())
		{
			m_EditBase.SetWindowText ("");
			m_EditBase.EnableWindow (false);
		}

		int sel = m_ComboType.GetCurSel ();

		m_ComboType.ResetContent ();
		m_ComboType.AddString ("k.n#+1");
		m_ComboType.AddString ("k.n#-1");
		m_ComboType.AddString ("Twin: k.n#1");
		m_ComboType.AddString ("SG: k.n#-1 & 2.k.n#-1");
		m_ComboType.AddString ("CC: k.n#+1 & 2.k.n#+1");
		m_ComboType.AddString ("BiTwin: k.n#1 & 2.k.n#1");
		m_ComboType.AddString ("Twin/SG: k.n#1 & 2.k.n#-1");
		m_ComboType.AddString ("Twin/CC: k.n#1 & 2.k.n#+1");
		m_ComboType.AddString ("LP: k.n#1 & .k.n#+1 & 2.k.n#+1");
		m_ComboType.AddString ("LM: k.n#1 & .k.n#-1 & 2.k.n#-1");
		m_ComboType.AddString ("CC 1st kind");
		m_ComboType.AddString ("CC 2nd kind");
		m_ComboType.AddString ("BiTwin");
		m_ComboType.AddString ("AP: n#+2k-1");
		m_ComboType.AddString ("3-tuple: k.n#/51 & k.n#/5+5");
		m_ComboType.AddString ("4-tuple: k.n#/351, +5, +7");
		m_ComboType.AddString ("PrimoProth: k#.2^n+1 with k fixed");
		m_ComboType.AddString ("PrimoProth: k#.2^n-1 with k fixed");
		m_ComboType.AddString (" Non-primorial sieves...");

		if (sel > 17) sel = 0;
		m_ComboType.SetCurSel (sel);
	}
	else
	{
		int sel = m_ComboType.GetCurSel ();

		if (m_RadioNew.GetCheck ())
		{
			m_EditBase.EnableWindow (true);
		}
		m_ComboType.ResetContent ();
		m_ComboType.AddString ("k.b^n+1");
		m_ComboType.AddString ("k.b^n-1");
		m_ComboType.AddString ("Twin: k.b^n1");
		if (fNotGeneralized)
		{
			m_ComboType.AddString ("SG: k.b^n-1 & 2k.b^n-1");
			m_ComboType.AddString ("CC: k.b^n+1 & 2k.b^n+1");
			m_ComboType.AddString ("BiTwin: k.b^n1 & 2k.b^n1");
			m_ComboType.AddString ("Twin/SG: k.b^n1 & 2k.b^n-1");
			m_ComboType.AddString ("Twin/CC: k.b^n1 & 2k.b^n+1");
		}
		else
		{
			m_ComboType.AddString ("SG: k.b^n-1 & k.b^(n+1)-1");
			m_ComboType.AddString ("CC: k.b^n+1 & k.b^(n+1)+1");
			m_ComboType.AddString ("BiTwin: k.b^n1 & k.b^(n+1)1");
			m_ComboType.AddString ("Twin/SG: k.b^n1 & k.b^(n+1)-1");
			m_ComboType.AddString ("Twin/CC: k.b^n1 & k.b^(n+1)+1");
		}
		m_ComboType.AddString ("LP: k.b^n1 & k.b^(n-1)+1 & k.b^(n+1)+1");
		m_ComboType.AddString ("LM: k.b^n1 & k.b^(n-1)-1 & k.b^(n+1)-1");
		m_ComboType.AddString ("CC 1st kind");
		m_ComboType.AddString ("CC 2nd kind");
		m_ComboType.AddString ("BiTwin");
		m_ComboType.AddString ("AP: b^n+2k-1 (-2 if b is odd)");
		m_ComboType.AddString ("3-tuple: k.b^n1 & k.b^n+5");
		m_ComboType.AddString ("4-tuple: k.b^n1, +5, +7");
		m_ComboType.AddString ("k.b^n+1 with k fixed");
		m_ComboType.AddString ("k.b^n-1 with k fixed");
		m_ComboType.AddString ("SG: k.b^n+1 & 2k.b^n+3");
		m_ComboType.AddString ("b^n+k with k fixed");
		m_ComboType.AddString ("b^n-k with k fixed");
		m_ComboType.AddString (" Primorial sieves...");

		if (sel > 20) sel = 0;
		m_ComboType.SetCurSel (sel);
	}

	if (m_ComboType.GetCurSel () >= 10 && m_ComboType.GetCurSel () <= 12)
	{
		m_StaticCCLen.ShowWindow (SW_SHOW);
		m_EditCCLen.ShowWindow (SW_SHOW);

		char buff[1024];
		m_EditCCLen.GetWindowText (buff, 1024);
		if (!buff[0])
		{
			m_EditCCLen.SetWindowText ("3");
		}
	}
	else
	{
		m_StaticCCLen.ShowWindow (SW_HIDE);
		m_EditCCLen.ShowWindow (SW_HIDE);
		m_EditCCLen.SetWindowText ("");
	}
	
	if (m_ComboType.GetCurSel () == 16 || m_ComboType.GetCurSel () == 17 || m_ComboType.GetCurSel () == 19 || m_ComboType.GetCurSel () == 20)
	{
		m_StaticN.SetWindowText ("&k:");
		m_StaticKMin.SetWindowText ("&nmin:");
		m_StaticKMax.SetWindowText ("nma&x:");
	}
	else
	{
		m_StaticN.SetWindowText ("&n:");
		m_StaticKMin.SetWindowText ("&kmin:");
		m_StaticKMax.SetWindowText ("kma&x:");
	}
}

bool CNewpgenDlg::HandleGeneralized ()
{
	char buff[1024];
	if (m_CheckPrimorial.GetCheck ())
	{
		m_Generalized.ShowWindow (SW_HIDE);
		return false;
	}
	m_EditBase.GetWindowText (buff, 1024);
	if (atoi (buff) == 0 || atoi (buff) == 2)
	{
		m_Generalized.ShowWindow (SW_HIDE);
		return false;
	}

	if ((m_ComboType.GetCurSel () < 3 || m_ComboType.GetCurSel () > 7)
	&&  (m_ComboType.GetCurSel () < 10 || m_ComboType.GetCurSel () > 12))
	{
		m_Generalized.ShowWindow (SW_HIDE);
		return false;
	}

	m_Generalized.ShowWindow (SW_SHOW);
	
	return (m_Generalized.GetCheck () == 0);
}

bool CNewpgenDlg::HandleEven ()
{
	char buff[1024];
	if (m_CheckPrimorial.GetCheck ())
	{
		m_CheckEven.ShowWindow (SW_HIDE);
		return false;
	}
	m_EditBase.GetWindowText (buff, 1024);
	if (atoi (buff) != 2)
	{
		m_CheckEven.ShowWindow (SW_HIDE);
		return false;
	}

	if (m_ComboType.GetCurSel () == 13 || m_ComboType.GetCurSel () == 16 || m_ComboType.GetCurSel () == 17 || m_ComboType.GetCurSel () == 19 || m_ComboType.GetCurSel () == 20)
	{
		// AP and fixed k sieves.
		m_CheckEven.ShowWindow (SW_HIDE);
		return false;
	}

	m_CheckEven.ShowWindow (SW_SHOW);
	
	return (m_CheckEven.GetCheck () != 0);
}


void CNewpgenDlg::OnCheckverify() 
{
	// TODO: Add your control notification handler code here
	if (m_CheckVerify.GetCheck ())
	{
		fVerify = true;
	}
	else 
	{
		fVerify = false;
	}
}

void CNewpgenDlg::OnOptionsSetbitmapsize() 
{
	// TODO: Add your command handler code here

	char buff[1024];
	sprintf (buff, "%.1f\n", BitMapThreshold/(1024.0*1024.0));

	DlgMaxBitmapSize dlgMaxBitmapSize;
	dlgMaxBitmapSize.DoModal ();
	WriteIniFile ();
}

void CNewpgenDlg::OnOptionsSetiterationsetweenwrites() 
{
	// TODO: Add your command handler code here
	IterationsBetweenWrites dlgIterations;
	dlgIterations.DoModal ();
	WriteIniFile ();
}

BOOL CNewpgenDlg::OnToolTip( UINT id, NMHDR * pNMHDR, LRESULT * pResult)
{
	char buff[1024];
	m_StaticKMin.GetWindowText (buff, 1024);

    TOOLTIPTEXT *pTTT = (TOOLTIPTEXT *)pNMHDR;
    UINT nID =pNMHDR->idFrom;
    if (pTTT->uFlags & TTF_IDISHWND)
    {
        // idFrom is actually the HWND of the tool
        nID = ::GetDlgCtrlID((HWND)nID);

        if(nID)
		{
			switch (nID)
			{
			case  IDSTART           : strcpy (pTTT->szText, "Press to start/stop sieving");break;
			case  IDC_RADIONEW      : strcpy (pTTT->szText, "Select if you want to create a new file");break;
			case  IDC_RADIOOLD      : strcpy (pTTT->szText, "Select if you want to continue sieving an old file");break;
			case  IDC_COMBO1        : strcpy (pTTT->szText, "Choose the type of sieve");break;
			case  IDC_STATICBASE    : 
			case  IDC_EDITBASE      : strcpy (pTTT->szText, "The base, b");break;
			case  IDC_STATICN       : 
			case  IDC_EDITN         : strcpy (pTTT->szText, "The value of n to use"); if (buff[1] == 'n') pTTT->szText[13] = 'k';break;
			case  IDC_STATICKMIN    : 
			case  IDC_EDITKMIN      : strcpy (pTTT->szText, "The minimum value of k in the sieve"); if (buff[1] == 'n') pTTT->szText[21] = 'n';break;
			case  IDC_STATICKMAX    : 
			case  IDC_EDITKMAX      : strcpy (pTTT->szText, "The maximum value of k in the sieve"); if (buff[1] == 'n') pTTT->szText[21] = 'n';break;
			case  IDC_EDITCCLEN     : 
			case  IDC_STATICCCLEN   : strcpy (pTTT->szText, "Set the chain length");break;
			case  IDC_STATICINFILE  : 
			case  IDC_EDITINFILE    : strcpy (pTTT->szText, "The input file if you are sieving an old file");break;
			case  IDC_EDITOUTFILE   : strcpy (pTTT->szText, "The output file to generate");break;
			case  IDC_RADIOPHIGH    : strcpy (pTTT->szText, "Run at high priority");break;
			case  IDC_RADIOPIDLE    : strcpy (pTTT->szText, "Run at idle priority");break;
			case  IDC_RADIOPNORMAL  : strcpy (pTTT->szText, "Run at normal priority");break;
			case  IDC_CHECKPRIMORIAL: strcpy (pTTT->szText, "Check this to use the primorial sieves");break;
			case  IDC_CHECKVERIFY   : strcpy (pTTT->szText, "Check this to verify that p really does divide the number");break;
			case  IDC_CHECKGENERALIZED   : strcpy (pTTT->szText, "Check this to create a 'generalized' chain");break;
			case  IDC_CHECKEVEN		: strcpy (pTTT->szText, "Check this to include even values of k in the sieve as well as odd values");break;
			case  IDC_BUTTONFIN		: strcpy (pTTT->szText, "Press this to choose the input file");break;
			case  IDC_BUTTONFOUT	: strcpy (pTTT->szText, "Press this to choose the output file");break;
			case  IDC_STATICORIG	: strcpy (pTTT->szText, "The number of candidates when the sieve started");break;
			case  IDC_STATICRATE	: strcpy (pTTT->szText, "The rate at which candidates are being removed");break;
			case  IDC_STATICSTATUS	: strcpy (pTTT->szText, "How far the sieving has got");break;
			default: return false;
			}
            return(TRUE);
		}
    }
    return(FALSE);

}


void CNewpgenDlg::OnMsieveuntil() 
{
	frmSieveUntil  dlg;
	dlg.DoModal();
	
}

void CNewpgenDlg::OnOptionsLog() 
{
	// TODO: Add your command handler code here
	if (GetMenu ()->GetMenuState (ID_OPTIONS_LOG, MF_BYCOMMAND) & MF_CHECKED)
	{
		GetMenu()->CheckMenuItem (ID_OPTIONS_LOG, MF_BYCOMMAND | MF_UNCHECKED);
		LogDeleted = false;
	}
	else
	{
		GetMenu()->CheckMenuItem (ID_OPTIONS_LOG, MF_BYCOMMAND | MF_CHECKED);
		LogDeleted = true;
		DontShowMe dlg("The removed k's will be appended to the file NEWPGEN.DEL, one per line.\r\nThis will only be done once p exceeds 2^32 (~4.3 billion), for the sake of performance.\r\nNote that this setting is reset when NewPGen starts up.", &DSM_LogDeleted);
		dlg.DoModal ();
	}
}

void CNewpgenDlg::OnOptionsUsetwosavefiles() 
{
	// TODO: Add your command handler code here
	if (GetMenu ()->GetMenuState (ID_OPTIONS_USETWOSAVEFILES, MF_BYCOMMAND) & MF_CHECKED)
	{
		GetMenu()->CheckMenuItem (ID_OPTIONS_USETWOSAVEFILES, MF_BYCOMMAND | MF_UNCHECKED);
		TwoSaveFiles = false;
	}
	else
	{
		GetMenu()->CheckMenuItem (ID_OPTIONS_USETWOSAVEFILES, MF_BYCOMMAND | MF_CHECKED);
		TwoSaveFiles = true;
		DontShowMe dlg("Before the output file is written, the previous contents will be saved to a file with the same name followed by a tilde\r\n(For example, work.dat would be saved to work.dat~)", &DSM_TwoSaveFiles);
		dlg.DoModal ();
	}
	WriteIniFile ();
}

void CNewpgenDlg::OnCheckgeneralized() 
{
	// TODO: Add your control notification handler code here
	OnCheckprimorial ();
}


void CNewpgenDlg::OnUtilsSeveralSplit() 
{
	// TODO: Add your command handler code here
	
	FrmSplit dlg;
	dlg.DoModal();
}


void CNewpgenDlg::OnUtilsSeveralMerge() 
{
	// TODO: Add your command handler code here
	
	frmMerge dlg;
	dlg.DoModal();
}


void CNewpgenDlg::OnServicesPrimalitytestonseveralmachines() 
{
	// TODO: Add your command handler code here
	frmTestSplit dlg;
	dlg.DoModal ();
}

void CNewpgenDlg::OnButtonfin() 
{
	// TODO: Add your control notification handler code here
	CFileDialog dlg (true, NULL, NULL, OFN_NOCHANGEDIR|OFN_FILEMUSTEXIST|OFN_HIDEREADONLY, "All files (*.*)|*.*|NewPGen files (*.npg)|*.npg||", NULL);

	dlg.m_ofn.lpstrTitle = "NewPGen input file";

	m_EditInFile.SetFocus ();

	if (dlg.DoModal() == IDOK)
	{
		m_EditInFile.SetWindowText (dlg.GetPathName ());
	}
}

void CNewpgenDlg::OnButtonfout() 
{
	// TODO: Add your control notification handler code here
	CFileDialog dlg (false, NULL, NULL, OFN_NOCHANGEDIR|OFN_NOTESTFILECREATE|OFN_HIDEREADONLY|OFN_PATHMUSTEXIST, "All files (*.*)|*.*|NewPGen files (*.npg)|*.npg||", NULL);

	dlg.m_ofn.lpstrTitle = "NewPGen output file";
	dlg.m_ofn.Flags &= ~OFN_OVERWRITEPROMPT;

	m_EditOutFile.SetFocus ();

	if (dlg.DoModal() == IDOK)
	{
		m_EditOutFile.SetWindowText (dlg.GetPathName ());
	}
	
}

void CNewpgenDlg::OnOptionsAutomaticallycontinuesievingthelastfileonstartup() 
{
	if (GetMenu ()->GetMenuState (ID_OPTIONS_AUTOMATICALLYCONTINUESIEVINGTHELASTFILEONSTARTUP, MF_BYCOMMAND) & MF_CHECKED)
	{
		GetMenu()->CheckMenuItem (ID_OPTIONS_AUTOMATICALLYCONTINUESIEVINGTHELASTFILEONSTARTUP, MF_BYCOMMAND | MF_UNCHECKED);
	}
	else
	{
		GetMenu()->CheckMenuItem (ID_OPTIONS_AUTOMATICALLYCONTINUESIEVINGTHELASTFILEONSTARTUP, MF_BYCOMMAND | MF_CHECKED);

		if (!(GetMenu ()->GetMenuState (ID_OPTIONS_USETWOSAVEFILES, MF_BYCOMMAND) & MF_CHECKED))
		{
			AfxMessageBox ("You have not checked the 'Use Two Save Files' option.\r\nIt is *highly recommended* that you check this option as well, otherwise you may lose your work.");
		}

	}
}

void CNewpgenDlg::PostNcDestroy() 
{
	// TODO: Add your specialized code here and/or call the base class

	delete this;
	// CDialog::PostNcDestroy();
}


#else		// GNUC or CONSOLE Platform

#include "NewpgenDlg_gnuc.cpp" 

#endif



