/////////////////////////////////////////////////////////
// Copyright (C)
//
// Filename    : Print.cpp
// Title       : Implementation of the Print function
// Release     : 1.0
// Date        : March 9th 1998
// Author(s)   : YG
// Description :
// 
/////////////////////////////////////////////////////////

#include "StdAfx.h"

#include "Print.h"

char printbuff[1024];

void print(LPCTSTR lpszText, DWORD dwData)
{
	COPYDATASTRUCT cds;
	cds.dwData = dwData;
	cds.cbData = (strlen(lpszText) + 1) * sizeof(TCHAR);
	cds.lpData = (void *)lpszText;
	HWND hMainWnd = AfxGetApp()->m_pMainWnd->GetSafeHwnd();
	if (hMainWnd != NULL)
		::SendMessage(hMainWnd, WM_COPYDATA, (WPARAM)hMainWnd, (LPARAM)&cds);
}

void __cdecl fprint(char *format, ...)
{
	va_list params;

	va_start (params, format);

	vsprintf (printbuff, format, params);
	print (printbuff);
}
