extern __int64 k0k1[2];		// k0 and k1
extern __int64 k2k3[2];		// k2 and k3
extern __int64 k4k5[2];		// k4 and k5
extern __int64 k6k7[2];		// k6 and k7
extern __int64 k8k9[2];		// k8 and k9
extern __int64 k10k11[2];	// k10 and k11

extern __int64 p0p1[4];		// p0p1 (128 bits), p0p1 >> 32 (128 bits)
extern __int64 p2p3[4];		// p2p3, p2p3 >> 32
extern __int64 p4p5[4];		// p3p4, p3p4 >> 32
extern __int64 p6p7[4];		// p6p7, p6p7 >> 32
extern __int64 p8p9[4];		// p8p9, p8p9 >> 32
extern __int64 p10p11[4];	// p10p11, p10p11 >> 32


#ifndef __GNUC__
void findk0xM_SSE2 () ;
#define LoadPValues_Macro(pa,pb,papb)						\
	__asm		mov		eax, dword ptr pa					\
	__asm		mov		ebx, dword ptr pa+4					\
	__asm		mov		ecx, dword ptr pb					\
	__asm		mov		edx, dword ptr pb+4					\
	__asm		mov		dword ptr papb, eax					\
	__asm		mov		dword ptr papb+4, ebx				\
	__asm		mov		dword ptr papb+8, ecx				\
	__asm		mov		dword ptr papb+12, edx				\
	__asm		mov		dword ptr papb+16, ebx				\
	__asm		mov		dword ptr papb+20, 0				\
	__asm		mov		dword ptr papb+24, edx				\
	__asm		mov		dword ptr papb+28, 0
#elif __GNUC__ < 3
#include "sse2multi.h"
#else
void findk0xM_SSE2() asm ("_Z13findk0xM_SSE2v"); // Taking on the name mangling...
#define LoadPValues_Macro(pa,pb,papb)\
	asm ("	movl		"#pa", %eax		");\
	asm ("	movl		"#pa"+4, %ebx	");\
	asm ("	movl		"#pb", %ecx		");\
	asm ("	movl		"#pb"+4, %edx	");\
	asm ("	movl		%eax, "#papb"	");\
	asm ("	movl		%ebx, "#papb"+4	");\
	asm ("	movl		%ecx, "#papb"+8	");\
	asm ("	movl		%edx, "#papb"+12	");\
	asm ("	movl		%ebx, "#papb"+16	");\
	asm ("	movl		$0, "#papb"+20	");\
	asm ("	movl		%edx, "#papb"+24	");\
	asm ("	movl		$0, "#papb"+28	")
#endif
