// newpgenDlg.h : header file
//

#if !defined(AFX_NEWPGENDLG_H__E4FEE36B_0881_11D4_8B2F_80D757C10000__INCLUDED_)
#define AFX_NEWPGENDLG_H__E4FEE36B_0881_11D4_8B2F_80D757C10000__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "EditDrop.h"

extern bool fAutoIncrement;
extern bool fPFGW;
extern char PFGWParameters[100];
extern int AutoIncrementAmount;

/////////////////////////////////////////////////////////////////////////////
// CNewpgenDlg dialog

class CNewpgenDlg : public CDialog
{
// Construction
public:
	CNewpgenDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CNewpgenDlg)
	enum { IDD = IDD_NEWPGEN_DIALOG };
	CButton	m_ButtonFout;
	CButton	m_ButtonFin;
	CStatic	m_StaticOrig;
	CButton	m_CheckEven;
	CButton	m_Generalized;
	CStatic	m_StaticN;
	CStatic	m_StaticKMin;
	CStatic	m_StaticKMax;
	CButton	m_CheckNotGeneralized;
	CStatic	m_StaticRate;
	CButton	m_CheckVerify;
	CButton	m_CheckPrimorial;
	CButton	m_PNormal;
	CButton	m_PIdle;
	CButton	m_PHigh;
	CEditDrop	m_EditOutFile;
	CEditDrop	m_EditInFile;
	CStatic	m_Status;
	CButton	m_RadioOld;
	CButton	m_RadioNew;
	CButton	m_StartButton;
	CEdit	m_Edit;
	CStatic	m_StaticCCLen;
	CComboBox	m_ComboType;
	CStatic	m_StaticB6;
	CStatic	m_StaticB1;
	CEdit	m_EditN;
	CEdit	m_EditKMin;
	CEdit	m_EditKMax;
	CEdit	m_EditCCLen;
	CEdit	m_EditBase;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CNewpgenDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	virtual void PostNcDestroy();
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;
	void TrayMessage(UINT message, LPCSTR prompt);
	LRESULT OnTrayMessage(UINT uID, LONG uMouseMsg);
	CWinThread *WorkerThread;
	void UpdateISL ();
	void DoSieving (bool fDoingAutoIncrement);
	BOOL OnToolTip( UINT id, NMHDR * pTTTStruct, LRESULT * pResult );
	bool HandleGeneralized ();
	bool HandleEven ();
	void WriteIniFile ();

	// Generated message map functions
	//{{AFX_MSG(CNewpgenDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnRadioold();
	afx_msg void OnRadionew();
	afx_msg void OnSelchangeCombo1();
	afx_msg void OnKillfocusEditcclen();
	afx_msg void OnSetfocusEditinfile();
	afx_msg void OnKillfocusEditinfile();
	afx_msg BOOL OnCopyData(CWnd* pWnd, COPYDATASTRUCT* pCopyDataStruct);
	afx_msg void OnKillfocusEditbase();
	afx_msg void OnKillfocusEditn();
	afx_msg void OnKillfocusEditkmin();
	afx_msg void OnKillfocusEditkmax();
	afx_msg void OnStart();
	afx_msg void OnFileExit();
	afx_msg void OnMAbout();
	afx_msg void OnMContents();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnDestroy();
	afx_msg void OnRadiophigh();
	afx_msg void OnRadiopidle();
	afx_msg void OnRadiopnormal();
	afx_msg void OnOptionTrayicon();
	afx_msg void OnOptionWorkerthreadpriorityLowest();
	afx_msg void OnOptionWorkerthreadpriorityNormal();
	afx_msg void OnOptionsSetinitialsievelimits();
	afx_msg void OnOptionsHide();
	afx_msg void OnCheckprimorial();
	afx_msg void OnCheckverify();
	afx_msg void OnOptionsSetbitmapsize();
	afx_msg void OnOptionsSetiterationsetweenwrites();
	afx_msg void OnOptionsGeneratepfgw();
	afx_msg void OnUtilityConvertasievedfiletopfgwformat();
	afx_msg void OnMsieveuntil();
	afx_msg void OnOptionsLog();
	afx_msg void OnCheckgeneralized();
	afx_msg void OnHelpWhatsnewinthisrelease();
	afx_msg void OnOptionsUsetwosavefiles();
	afx_msg void OnUtilsSeveralSplit();
	afx_msg void OnUtilsSeveralMerge();
	afx_msg void OnButtonfin();
	afx_msg void OnButtonfout();
	afx_msg void OnServicesPrimalitytestonseveralmachines();
	afx_msg void OnOptionsAutomaticallycontinuesievingthelastfileonstartup();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_NEWPGENDLG_H__E4FEE36B_0881_11D4_8B2F_80D757C10000__INCLUDED_)
