// frmPCSpeed.cpp : implementation file
//

#include "stdafx.h"
#include "newpgen.h"
#include "frmPCSpeed.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// frmPCSpeed dialog


frmPCSpeed::frmPCSpeed(int num, bool fLast, int initspeed, CWnd* pParent /*=NULL*/)
	: CDialog(frmPCSpeed::IDD, pParent), m_num (num), m_fLast (fLast), m_SpeedMHz (initspeed)
{
	//{{AFX_DATA_INIT(frmPCSpeed)
	//}}AFX_DATA_INIT
}


void frmPCSpeed::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(frmPCSpeed)
	DDX_Control(pDX, IDC_STATIC1, m_Static);
	DDX_Control(pDX, IDC_EDIT1, m_Speed);
	DDX_Control(pDX, IDOK, m_OK);
	DDX_Control(pDX, IDCANCEL, m_Cancel);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(frmPCSpeed, CDialog)
	//{{AFX_MSG_MAP(frmPCSpeed)
	ON_WM_SHOWWINDOW()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// frmPCSpeed message handlers

BOOL frmPCSpeed::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	char buff[1024];
	sprintf (buff, "&Speed of machine %d:", m_num);

	m_Static.SetWindowText (buff);

	sprintf (buff, "Speed of machine %d (must be more than 33 MHz)", m_num);
	this->SetWindowText (buff);

	if (m_SpeedMHz)
	{
		sprintf (buff, "%d", m_SpeedMHz);
		m_Speed.SetWindowText (buff);
	}

	m_Cancel.SetWindowText ((m_num == 1) ? "Cancel" : " Back");
	m_OK.SetWindowText ((m_fLast) ? "OK" : "Next ");

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void frmPCSpeed::OnCancel() 
{
	m_Button = IDCANCEL;	
	CDialog::OnCancel();
}

void frmPCSpeed::OnOK() 
{
	char buff[1024];

	m_Button = IDOK;
	m_Speed.GetWindowText (buff, 1024);
	m_SpeedMHz = atoi (buff);

	if (m_SpeedMHz < 33) return;

	CDialog::OnOK();
}

void frmPCSpeed::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	
	// TODO: Add your message handler code here
	
	m_Speed.SetFocus ();

}
