// frmSieveUntil.cpp : implementation file
//

#include "stdafx.h"
#include "newpgen.h"
#include "frmSieveUntil.h"
#include "newpgen2.h"
#include "newpgendlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// frmSieveUntil dialog


frmSieveUntil::frmSieveUntil(CWnd* pParent /*=NULL*/)
	: CDialog(frmSieveUntil::IDD, pParent)
{
	//{{AFX_DATA_INIT(frmSieveUntil)
	//}}AFX_DATA_INIT
}


void frmSieveUntil::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(frmSieveUntil)
	DDX_Control(pDX, IDC_STATIC_PFGWPARAMS, m_StaticPFGWParams);
	DDX_Control(pDX, IDC_EDIT5, m_PFGWParams);
	DDX_Control(pDX, IDC_AUTOINCREMENT3, m_PFGW);
	DDX_Control(pDX, IDC_EDITMAXN, m_EditMaxN);
	DDX_Control(pDX, IDC_AUTOINCREMENT2, m_MaxN);
	DDX_Control(pDX, IDC_EDITINC, m_EditInc);
	DDX_Control(pDX, IDC_AUTOINCREMENT, m_Autoincrement);
	DDX_Control(pDX, IDC_RADIO5, m_Radio5);
	DDX_Control(pDX, IDC_RADIO4, m_Radio4);
	DDX_Control(pDX, IDC_RADIO3, m_Radio3);
	DDX_Control(pDX, IDC_RADIO2, m_Radio2);
	DDX_Control(pDX, IDC_RADIO1, m_Radio1);
	DDX_Control(pDX, IDC_EDIT4, m_Edit4);
	DDX_Control(pDX, IDC_EDIT3, m_Edit3);
	DDX_Control(pDX, IDC_EDIT2, m_Edit2);
	DDX_Control(pDX, IDC_EDIT1, m_Edit1);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(frmSieveUntil, CDialog)
	//{{AFX_MSG_MAP(frmSieveUntil)
	ON_BN_CLICKED(IDC_RADIO1, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO2, OnRadio2)
	ON_BN_CLICKED(IDC_RADIO3, OnRadio3)
	ON_BN_CLICKED(IDC_RADIO4, OnRadio4)
	ON_BN_CLICKED(IDC_RADIO5, OnRadio5)
	ON_BN_CLICKED(IDC_AUTOINCREMENT, OnAutoincrement)
	ON_EN_CHANGE(IDC_EDIT4, OnChangeEdit4)
	ON_EN_KILLFOCUS(IDC_EDIT1, OnKillfocusEdit1)
	ON_EN_KILLFOCUS(IDC_EDIT2, OnKillfocusEdit2)
	ON_EN_KILLFOCUS(IDC_EDIT3, OnKillfocusEdit3)
	ON_EN_KILLFOCUS(IDC_EDIT4, OnKillfocusEdit4)
	ON_BN_CLICKED(IDC_AUTOINCREMENT2, OnAutoincrement2)
	ON_BN_CLICKED(IDC_AUTOINCREMENT3, OnAutoincrement3)
	ON_EN_KILLFOCUS(IDC_EDIT5, OnKillfocusEdit5)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// frmSieveUntil message handlers

void frmSieveUntil::OnRadio1() 
{
	// TODO: Add your control notification handler code here

	StopCriterion = NONE;
	UpdateThings ();
}

void frmSieveUntil::OnRadio2() 
{
	// TODO: Add your control notification handler code here
	char buff[1024];

	m_Edit1.GetWindowText (buff, 1024);
	StopValue = _atoi64 (buff);
	if (StopValue < 1000) StopValue = 1000;
	StopCriterion = MAXP;
	UpdateThings ();
}

void frmSieveUntil::OnRadio3() 
{
	// TODO: Add your control notification handler code here
	char buff[1024];

	m_Edit2.GetWindowText (buff, 1024);
	StopValue = _atoi64 (buff);
	if (StopValue < 1) StopValue = 1000;
	StopCriterion = KSREMAINING;
	UpdateThings ();
}

void frmSieveUntil::OnRadio4() 
{
	// TODO: Add your control notification handler code here
	char buff[1024];

	m_Edit3.GetWindowText (buff, 1024);
	StopValue = _atoi64 (buff);
	if (StopValue < 1) StopValue = 24;
	StopCriterion = DATETIME;
	UpdateThings ();
	
}

void frmSieveUntil::OnRadio5() 
{
	// TODO: Add your control notification handler code here
	char buff[1024];

	m_Edit4.GetWindowText (buff, 1024);
	StopValue = (__int64) (10*atof (buff));
	if (StopValue < 1) StopValue = 1;
	StopCriterion = RATE;
	UpdateThings ();
	
}

void frmSieveUntil::UpdateThings ()
{
	char buff[1024];
	char ratebuff[1024];
	sprintf (buff, "%I64d", StopValue);
	sprintf (ratebuff, "%.1f", StopValue/10.0);

	// TODO: Add extra initialization here
	m_Radio1.SetCheck (StopCriterion == NONE ? 1 : 0);
	m_Radio2.SetCheck (StopCriterion == MAXP ? 1 : 0);
	m_Radio3.SetCheck (StopCriterion == KSREMAINING ? 1 : 0);
	m_Radio4.SetCheck (StopCriterion == DATETIME ? 1 : 0);
	m_Radio5.SetCheck (StopCriterion == RATE ? 1 : 0);

	m_Edit1.EnableWindow (StopCriterion == MAXP ? true : false);
	m_Edit2.EnableWindow (StopCriterion == KSREMAINING ?  true : false);
	m_Edit3.EnableWindow (StopCriterion == DATETIME ? true : false);
	m_Edit4.EnableWindow (StopCriterion == RATE ? true : false);
	
	m_Edit1.SetWindowText ("");
	m_Edit2.SetWindowText ("");
	m_Edit3.SetWindowText ("");
	m_Edit4.SetWindowText ("");
	m_Autoincrement.EnableWindow (StopCriterion == NONE ? false : true);
	m_PFGW.EnableWindow (StopCriterion == NONE ? false : true);
	m_PFGWParams.EnableWindow (false);
	m_StaticPFGWParams.EnableWindow (false);

	switch (StopCriterion)
	{
	case MAXP: m_Edit1.SetWindowText (buff); break;
	case KSREMAINING: m_Edit2.SetWindowText (buff); break;
	case DATETIME: m_Edit3.SetWindowText (buff); break;
	case RATE: m_Edit4.SetWindowText (ratebuff); break;
	}

	if (m_PFGW.IsWindowEnabled () && m_PFGW.GetCheck ())
	{
		if (!fTest)	// fTest means under test, not in the released version.
		{
			m_MaxN.EnableWindow (false);
			m_MaxN.SetCheck (false);
			m_Autoincrement.EnableWindow (false);
			m_Autoincrement.SetCheck (false);
		}
		m_PFGWParams.EnableWindow (true);
		m_StaticPFGWParams.EnableWindow (true);
		m_PFGWParams.SetWindowText (PFGWParameters);
	}
	else
	{
		m_PFGWParams.SetWindowText ("");
	}

	if (m_Autoincrement.IsWindowEnabled () && m_Autoincrement.GetCheck ())
	{
		char buff[1024];
		m_EditInc.GetWindowText (buff, 1024);
		AutoIncrementAmount = atoi (buff);
		if (AutoIncrementAmount < 1) AutoIncrementAmount = 1;
		m_EditInc.EnableWindow (true);
		sprintf (buff, "%d", AutoIncrementAmount);
		m_EditInc.SetWindowText (buff);	

		m_MaxN.EnableWindow (true);

		if (!fTest)	// fTest means under test, not in the released version.
		{
			m_PFGW.EnableWindow (false);
			m_PFGWParams.EnableWindow (false);
			m_StaticPFGWParams.EnableWindow (false);
			m_PFGW.SetCheck (false);
		}

		if (m_MaxN.GetCheck ())
		{
			char buff[1024];
			m_EditMaxN.GetWindowText (buff, 1024);
			int MaxN = atoi (buff);
			if (MaxN < 1) MaxN = 1;
			m_EditMaxN.EnableWindow (true);
			sprintf (buff, "%d", MaxN);
			m_EditMaxN.SetWindowText (buff);	
		}
		else
		{
			m_EditMaxN.EnableWindow (false);
			m_EditMaxN.SetWindowText ("");
		}
	}
	else
	{
		m_EditInc.EnableWindow (false);
		m_EditInc.SetWindowText ("");
		m_MaxN.EnableWindow (false);
		m_MaxN.SetCheck (false);
		m_EditMaxN.EnableWindow (false);
		m_EditMaxN.SetWindowText ("");
	}
}

BOOL frmSieveUntil::OnInitDialog() 
{
	CDialog::OnInitDialog();

	OldStopCriterion = StopCriterion;
	OldStopValue = StopValue;

	m_Autoincrement.SetCheck (fAutoIncrement);
	if (fAutoIncrement)
	{
		char buff[1024];
		m_EditInc.EnableWindow (true);
		sprintf (buff, "%d", AutoIncrementAmount);
		m_EditInc.SetWindowText (buff);	

		if (MaxN)
		{
			m_MaxN.SetCheck (true);
			char buff[1024];
			m_EditMaxN.EnableWindow (true);
			sprintf (buff, "%d", MaxN);
			m_EditMaxN.SetWindowText (buff);	
		}
		else
		{
			m_MaxN.SetCheck (false);
		}
	}
	else
	{
		m_PFGW.SetCheck (fPFGW);
	}

	UpdateThings ();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void frmSieveUntil::OnOK() 
{
	// TODO: Add extra validation here
	if (m_Radio1.GetCheck ()) OnRadio1 ();
	else if (m_Radio2.GetCheck ()) OnRadio2 ();
	else if (m_Radio3.GetCheck ()) OnRadio3 ();
	else if (m_Radio4.GetCheck ()) OnRadio4 ();
	else if (m_Radio5.GetCheck ()) OnRadio5 ();

	if (m_Autoincrement.IsWindowEnabled () && m_Autoincrement.GetCheck ())
	{
		char buff[1024];
		fAutoIncrement = true;
		m_EditInc.GetWindowText (buff, 1024);
		AutoIncrementAmount = atoi (buff);
		if (AutoIncrementAmount < 1)
		{
			AfxMessageBox ("You must set a valid amount to increment by!");
			return;
		}
	}
	else
	{
		fAutoIncrement = false;
	}

	if (m_PFGW.IsWindowEnabled () && m_PFGW.GetCheck ())
	{
		fPFGW = true;

		FILE *fptr = fopen ("PFGW.exe", "r");

		if (fptr)
		{
			fclose (fptr);
			m_PFGWParams.GetWindowText (PFGWParameters, 90);

			// Strip leading/trailing whitespace from the parameters
			while (isspace (PFGWParameters[strlen (PFGWParameters)-1]))
			{
				PFGWParameters[strlen (PFGWParameters)-1] = 0;
			}
			while (isspace (PFGWParameters[0]))
			{
				memmove (PFGWParameters, PFGWParameters+1, strlen (PFGWParameters));
			}
		}
		else
		{
			char mess[10240];
			char PFGWstring[_MAX_PATH];

			_fullpath(PFGWstring, ".\\PFGW.exe", _MAX_PATH );
			sprintf (mess, "I cannot find PFGW.exe in the current directory (i.e. %s)\r\nTo automatically call PFGW, it must be in the current directory.", PFGWstring);
			AfxMessageBox (mess);
			return;
		}
	}
	else
	{
		fPFGW = false;
		PFGWParameters[0] = 0;

	}

	if (m_MaxN.IsWindowEnabled () && m_MaxN.GetCheck ())
	{
		char buff[1024];
		m_EditMaxN.GetWindowText (buff, 1024);
		MaxN = atoi (buff);
		if (MaxN < 1)
		{
			AfxMessageBox ("You must set a maximum value for N!!");
			return;
		}
	}
	else
	{
		MaxN = 0;
	}

	CDialog::OnOK();
}

void frmSieveUntil::OnCancel() 
{
	// TODO: Add extra cleanup here
	StopCriterion = OldStopCriterion;
	StopValue = OldStopValue;

	CDialog::OnCancel();
}

void frmSieveUntil::OnAutoincrement() 
{
	// TODO: Add your control notification handler code here
	UpdateThings ();
}

void frmSieveUntil::OnChangeEdit4() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	char buff[1024];

	m_Edit4.GetWindowText (buff, 1024);

	// Ought to be just numbers and one '.' in there...
	int DPindex = 9999;

	for (int i = 0; buff[i]; i++)
	{
		if (!isdigit (buff[i]))
		{
			if (buff[i] != '.' || DPindex != 9999)
			{
				buff[i] = 0;
				MessageBeep (0xFFFFFFFF);
				m_Edit4.SetWindowText (buff);
				m_Edit4.SetSel (1000, 1000);
				return;
			}
			if (buff[i] == '.') DPindex = i;
		}
		else if (DPindex < i-1)
		{
			buff[i] = 0;
			MessageBeep (0xFFFFFFFF);
			m_Edit4.SetWindowText (buff);
			m_Edit4.SetSel (1000, 1000);
			return;
		}
	}
}

void frmSieveUntil::OnKillfocusEdit1() 
{
	// TODO: Add your control notification handler code here
	
	char buff[1024];
	m_Edit1.GetWindowText (buff, 1024);
	StopValue = _atoi64 (buff);
	if (StopValue < 1000) StopValue = 1000;
}

void frmSieveUntil::OnKillfocusEdit2() 
{
	// TODO: Add your control notification handler code here
	char buff[1024];
	m_Edit2.GetWindowText (buff, 1024);
	StopValue = _atoi64 (buff);
	if (StopValue < 1) StopValue = 1000;
	
}

void frmSieveUntil::OnKillfocusEdit3() 
{
	// TODO: Add your control notification handler code here
	char buff[1024];
	m_Edit3.GetWindowText (buff, 1024);
	StopValue = _atoi64 (buff);
	if (StopValue < 1) StopValue = 24;
	
}

void frmSieveUntil::OnKillfocusEdit4() 
{
	// TODO: Add your control notification handler code here
	char buff[1024];

	m_Edit4.GetWindowText (buff, 1024);
	StopValue = __int64 (10*atof (buff));
	if (StopValue < 1) StopValue = 1;
	
}

void frmSieveUntil::OnAutoincrement2() 
{
	// TODO: Add your control notification handler code here
	UpdateThings ();
}

void frmSieveUntil::OnAutoincrement3() 
{
	// TODO: Add your control notification handler code here
	UpdateThings ();
	
}

void frmSieveUntil::OnKillfocusEdit5() 
{
	// TODO: Add your control notification handler code here
	
	m_PFGWParams.GetWindowText (PFGWParameters, 90);
}
